unit fMHA_ASI_Close;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  fIA_Dialogs,
  RzPanel,
  RzRadGrp,
  ExtCtrls,
  EsGrad,
  ComCtrls,
  jpeg,
  StdCtrls,
  RzLabel,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons;

type
  TfrmMHA_ASI_Close = class(TForm)
    pnlHeader: TRzPanel;
    lblHeader: TRzLabel;
    StatusBar1: TStatusBar;
    pnlButtons: TPanel;
    btnReturn: TJvXPButton;
    btnExit: TJvXPButton;
    btnFinish: TJvXPButton;
    btnSave: TJvXPButton;
    procedure FormCreate(Sender: TObject);
    procedure ConfigureForm;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnReturnClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure btnFinishClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure FormResize(Sender: TObject);

  private
    { Private declarations }
    FCloseResponse: Char;
  public
    { Public declarations }
    property CloseResponse: Char read FCloseResponse;
                             // Letters used are: C-Close, E-Exit, F-Finish later
                             // S-Save/Verify/Sign it
  end;

var
  frmMHA_ASI_Close            : TfrmMHA_ASI_Close;

implementation

{$R *.DFM}

uses
  uMHA_ASI,
  uMHA_ASI_OPS,
  uIA_Const,
  uMHA_Const,
  uIA_GUIControl;

var
  lvInitialize                : Boolean;

procedure TfrmMHA_ASI_Close.FormCreate(Sender: TObject);
//var
//  WhereMouse                  : TPoint;
begin
//  WhereMouse.X := Screen.WorkAreaWidth div 2;
//  WhereMouse.Y := Screen.WorkAreaHeight div 2;
//  Mouse.CursorPos := WhereMouse;
  lvInitialize := True;
  Position := poDesigned;

  if TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).CanBeSignedByUser then
    begin
      btnSave.Caption := '&Save and Sign';
      StatusBar1.visible := false;
    end
  else
    begin
      btnSave.Caption := '&Save; Sign later';
      StatusBar1.Panels[0].Text := 'Only "Ordered By" may sign: ' +
        TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).OrderedByName;
    end;

  ConfigureForm;
  Screen.cursor := crDefault;
  lvInitialize := False;
  ActiveControl := btnReturn;
  ShowModal;
end;

(*
procedure TfrmMHA_ASI_Close.FormKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
    'S', 's':
      if TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).CanBeSignedByUser then
        FCloseResponse := 'S' // save, verify, sign it
      else
        begin
          MsgDlg(lvMsg, MHA_Caption, mtInformation, [mbOK], 0);
          Exit;
        end;
    'F', 'f': FCloseResponse := 'F'; // finish later
    'E', 'e':
      begin
        if MsgDlg('Are you sure you want to exit this ASI without saving?',
          MHA_Caption, mtConfirmation, [mbYes, mbNo], 0) = mrNo then
          Exit;
        FCloseResponse := 'E'; // exit now
      end;
    'C', 'c': FCloseResponse := 'C'; // close/cancel, return to program
  end; // case
  Close;
end;  *)

(*
procedure TfrmMHA_ASI_Close.lblReturnClick(Sender: TObject);
begin

end;

procedure TfrmMHA_ASI_Close.lblFinishClick(Sender: TObject);
begin

end;

procedure TfrmMHA_ASI_Close.lblExitClick(Sender: TObject);
begin

end;

procedure TfrmMHA_ASI_Close.lblSignClick(Sender: TObject);
begin

end; *)

procedure TfrmMHA_ASI_Close.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_Escape then
    begin
      FCloseResponse := 'C'; // close/cancel, return to program
      Close;
      Key := 0;
    end;
end;

procedure TfrmMHA_ASI_Close.ConfigureForm;
begin
  with GUI_Control do
    begin
      Scaled := True;
      AutoScroll := False;
      AutoSize := False;
      PixelsPerInch := 120;
      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(gvFont);

      Height := GetHeight(pnlHeaderHeight + (9 * ButtonHeight));
      Width := GetWidth(3 * ButtonWidth(btnSave.Caption));
      Left := GetLeft(Width);
      Top := GetTop(Height);
      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      Refresh; // resets alClient dimensions

      pnlHeader.Height := pnlHeaderHeight;
      StatusBar1.Height := 3 * (TextHeight('Yy', gvFont) div 2);
      lblHeader.Font.Assign(gvFont);
      lblheader.Font.Size := lblHeaderFontSize;

      btnReturn.Height := ButtonHeight;
      btnExit.Height := ButtonHeight;
      btnFinish.Height := ButtonHeight;
      btnSave.Height := ButtonHeight;

      btnSave.Width := ButtonWidth(btnSave.Caption);
      btnReturn.Width := btnSave.Width;
      btnExit.Width := btnSave.Width;
      btnFinish.Width := btnSave.Width;

      btnReturn.Left := (pnlButtons.Width - btnSave.Width) div 2;
      btnExit.Left := btnReturn.Left;
      btnFinish.Left := btnReturn.Left;
      btnSave.Left := btnReturn.Left;

      btnReturn.Top := (pnlButtons.Height - (4 * ButtonHeight)) div 5;
      btnExit.Top := (2 * btnReturn.Top) + ButtonHeight;
      btnFinish.Top := (3 * btnReturn.Top) + (2 * ButtonHeight);
      btnSave.Top := (4 * btnReturn.Top) + (3 * ButtonHeight);

      if gvUseScreenReader then
        begin
          btnReturn.caption := btnReturn.Caption + ' button';
          btnExit.caption := btnExit.Caption + ' button';
          btnFinish.caption := btnFinish.Caption + ' button';
          btnSave.caption := btnSave.Caption + ' button';
        end;

    end;
end;

procedure TfrmMHA_ASI_Close.btnReturnClick(Sender: TObject);
begin
  FCloseResponse := 'C'; // close/cancel, return to program
  Close;
end;

procedure TfrmMHA_ASI_Close.btnExitClick(Sender: TObject);
begin
  if MsgDlgFrm('Are you sure you want to exit this ASI without saving?',
    MHA_Caption, mtConfirmation, [mbYes, mbNo], 0) = mrNo then
    Exit;
  FCloseResponse := 'E'; // exit now
  Close;
end;

procedure TfrmMHA_ASI_Close.btnFinishClick(Sender: TObject);
begin
  FCloseResponse := 'F'; // finish later
  Close;
end;

procedure TfrmMHA_ASI_Close.btnSaveClick(Sender: TObject);
begin
  FCloseResponse := 'S'; // save, verify; perhaps, sign it
  Close;
end;

procedure TfrmMHA_ASI_Close.FormResize(Sender: TObject);
begin
  if lvInitialize then
    Exit;

  // Reset these, used in placement of dialogs
  gvLeft := Left;
  gvTop := Top;
  gvHeight := Height;
  gvWidth := Width;
end;

end.

