unit fMHA_AppendComments;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  ExtCtrls,
  StdCtrls,
  RzLabel,
  RzPanel,
  ComCtrls,
  Menus,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons;

type
  TfrmMHA_AppendComments = class(TForm)
    pnlHeader: TRzPanel;
    lblHeader: TRzLabel;
    lblPatient: TRzLabel;
    pnlTopSpacer: TPanel;
    Splitter1: TSplitter;
    pnlOld: TPanel;
    pnlNew: TPanel;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuSave: TMenuItem;
    N1: TMenuItem;
    mnuExit: TMenuItem;
    pnlHeaderSpacer: TPanel;
    mnuHelp: TMenuItem;
    mnuOnlineSupport: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    grpOldComments: TRzGroupBox;
    memOld: TRichEdit;
    grpNewComments: TRzGroupBox;
    pnlButtons: TPanel;
    btnCancel: TJvXPButton;
    btnSave: TJvXPButton;
    memNew: TRichEdit;
    imgBackup: TImage;
    procedure mnuExitClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mnuSaveClick(Sender: TObject);
    procedure memNewChange(Sender: TObject);
    //procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure About1Click(Sender: TObject);
    procedure mnuOnlineSupportClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnSaveClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure ConfigureForm;
    procedure FormCreate(Sender: TObject);
    procedure imgBackupClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    procedure ClearNewComments;
    procedure SaveCommentsToVista(aAdminID: string);
  public
    { Public declarations }
    procedure DisplayOldComments(Header, aAdminID: string);
  end;

var
  frmMHA_AppendComments       : TfrmMHA_AppendComments;

implementation

uses
  uIA_Const,
  uMHA_Const,
  uMHA_Registry,
  uIA_Patient,
  uIA_GUIControl,
  uIA_Utils,
  fIA_Dialogs,
  fMHA_About,
  uIA_ThisUser,
  uMHA_Report_OPS,
  uMHA_AResult,
  uMHA_Result_OPS,
  uMHA_DM;

{$R *.DFM}

var
  lvComments,
    lvAdminID                 : string;
  lvInitialize                : Boolean;


procedure TfrmMHA_AppendComments.FormCreate(Sender: TObject);
begin
  lvInitialize := True;
  Position := poDesigned;
  ConfigureForm;
  lvComments := '';
end;



procedure TfrmMHA_AppendComments.FormShow(Sender: TObject);
begin
  //This has to be on FormShow because you cannot set focus on FormCreate
  ClearNewComments;
  Screen.cursor := crDefault;
  lvInitialize := False;

  if gvUseScreenReader then
    ActiveControl := grpOldComments
  else
    ActiveControl := memNew;
end;

procedure TfrmMHA_AppendComments.ConfigureForm;
begin
  // FormResize for left button positions.
  with GUI_Control do
    begin
      Scaled := True;
      AutoScroll := False;
      AutoSize := False;
      PixelsPerInch := 120;
      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(gvFont);

      Height := GetHeight(gvHeight);
      Width := GetWidth(gvWidth);
      Left := GetLeft(Width);
      Top := GetTop(Height);
      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      Refresh; // resets alClient dimensions

      with memOld do
        begin
          PlainText := False;
          Font.Name := 'Courier New';
          Font.Size := gvFont.Size;
          Font.Color := gvFont.color;
          Font.Style := gvFont.style;
          MaxLength := Length(Text);
        end;

      with memNew do
        begin
          PlainText := False;
          Font.Name := 'Courier New';
          Font.Size := gvFont.Size;
          Font.Color := gvFont.color;
          Font.Style := gvFont.style;
          MaxLength := Length(Text);
        end;

      pnlHeader.Height := pnlHeaderHeight;

      with lblHeader do
        begin
          ShowHint := True;
          Font.Assign(Font);
          Font.Size := lblHeaderFontSize;
          Font.Color := clBlack;
          Height := lblHeaderHeight;
          AutoSize := True;
          Layout := tlCenter;
          Align := alClient;
          Color := clWhite;
          //Width := 4 * pnlHeader.Width div 5;
        end;

      with lblPatient do
        begin
          Font.Assign(Font);
          Font.Size := lblPatientFontSize;
          Font.Color := clBlack;
          Color := clWhite;
          Layout := tlCenter;
          Align := alRight;
          AutoSize := false;
          Caption := Patient.CaptionInfo;
          Width := TextWidth(Caption, Font);
        end;

      pnlButtons.Height := (3 * ButtonHeight) div 2;
      btnSave.Height := ButtonHeight;
      btnCancel.Height := ButtonHeight;
      btnSave.Width := ButtonWidth(btnSave.Caption);
      btnCancel.Width := ButtonWidthNormal;
      btnSave.Top := (pnlButtons.Height - ButtonHeight) div 2;
      btnCancel.Top := btnSave.Top;
    end;

  if gvUseScreenReader then
    begin
      Left := 0;
      Width := Screen.Width;
      Caption := 'Add comments for patient ' + Patient.Name;
      grpOldComments.TabStop := True;
      grpNewComments.TabStop := True;
      grpOldComments.Caption := 'The previous comments provided below, ' +
        'cannot be edited. Use tab key to enter.';
      grpNewComments.Caption := ' Append the comments below. Press the tab ' +
        'key to enter.';

      btnSave.caption := btnSave.Caption + ' button';
      btnCancel.caption := btnCancel.Caption + ' button';
    end
  else
    begin
      grpOldComments.TabStop := False;
      grpNewComments.TabStop := False;
      grpOldComments.Caption := '  Previous Comments';
      grpNewComments.Caption := '  New Comments';
    end;
end;

procedure TfrmMHA_AppendComments.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_AppendComments.DisplayOldComments(Header, aAdminID: string);
var
  i                           : integer;

begin
  lvAdminID := aAdminID;

  if Header <> '' then
    lblHeader.Caption := '  ' + Header;

  memOld.Clear;
  memOld.SelStart := 0;

  lvComments := Result_OPS.LoadComments(lvAdminID);

  if lvComments <> '' then
    begin
      for i := 1 to NumberOfPieces(lvComments, RECORD_END) do
        memOld.Lines.Add(Piece(lvComments, RECORD_END, i));
    end
  else
    memOld.Lines.Add('None');
end;

procedure TfrmMHA_AppendComments.mnuSaveClick(Sender: TObject);
begin
  SaveCommentsToVista(lvAdminID);
  ClearNewComments;
  DisplayOldComments('', lvAdminID);
end;

procedure TfrmMHA_AppendComments.ClearNewComments;
begin
  memNew.Lines.Clear;
  memNew.SetFocus;
  mnuSave.Enabled := False;
end;

procedure TfrmMHA_AppendComments.memNewChange(Sender: TObject);
begin
  mnuSave.Enabled := (Length(memNew.Text) > 0);
end;

procedure TfrmMHA_AppendComments.SaveCommentsToVista(aAdminID: string);
var
  tmpMsg, tmpComments         : string;
  i                           : integer;
begin
  if memNew.Text = '' then
    Exit;

  tmpComments := '***  Comment Entered By:  ' + ThisUser.Name
    + '  Comment Date:  ' + DateTimeToStr(Now) + RECORD_END + RECORD_END;

  for i := 0 to memNew.Lines.Count - 1 do
    tmpComments := tmpComments + memNew.Lines[i] + RECORD_END;

  lvComments := tmpComments + lvComments;

  tmpMsg := MHA_Report_OPS.SaveComments(aAdminID, lvComments);

  if not (tmpMsg = OK) then
    MsgDlgFrm(tmpMsg, MHA_Caption, mtError, [mbOK], 0);
end;

(*procedure TfrmMHA_AppendComments.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
const
  tmpMsg                      = 'New comments have not been saved.  Do you want to  save them now?' +
    CRLF + CRLF +
    '(Click "Cancel" to continue editing new comments.)';

begin
  //mnuSave is enabled if comments have been entered but not saved
  CanClose := not mnuSave.Enabled;

  if not CanClose then
    case MsgDlgFrm(tmpMsg, MHA_Caption, mtConfirmation, [mbYes, mbNo, mbCancel],
      0) of
      mrYes:
        begin
          SaveCommentsToVista(lvAdminID);
          CanClose := True;
        end;
      mrNo: CanClose := True;
    end;
end;*)

procedure TfrmMHA_AppendComments.About1Click(Sender: TObject);
begin
  frmMHA_About := TfrmMHA_About.Create(nil);
  try
    frmMHA_About.ShowModal;
  finally
    frmMHA_About.Free;
  end; //try
end;

procedure TfrmMHA_AppendComments.mnuOnlineSupportClick(Sender: TObject);
begin
  VisitURL(MHA_ONLINE_SUPPORT_URL);
end;

procedure TfrmMHA_AppendComments.FormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Shift = [ssALT]) and (Key = vk_F4) then
    Close;

  if Key = vk_Escape then
    begin
      Close;
      Key := 0;
    end;

end;

procedure TfrmMHA_AppendComments.btnSaveClick(Sender: TObject);
begin
  SaveCommentsToVista(lvAdminID);
  Close;
end;

procedure TfrmMHA_AppendComments.btnCancelClick(Sender: TObject);
begin
  Close;
end;


procedure TfrmMHA_AppendComments.imgBackupClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_AppendComments.FormResize(Sender: TObject);
begin
  btnSave.Left := pnlButtons.Width - btnSave.Width - (btnCancel.Width div 3);
  btnCancel.Left := btnCancel.Width div 3;

  if lvInitialize then
    Exit;

  // Reset these, used in placement of dialogs
  gvLeft := Left;
  gvTop := Top;
  gvHeight := Height;
  gvWidth := Width;
end;

end.

