unit fMHA_InstrumentResults;

interface

uses
  Windows,
  Messages,
  SysUtils,
  DateUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Menus,
  ComCtrls,
  ExtCtrls,
  StdCtrls,
  Contnrs,
  Grids,
  BaseGrid,
  AdvGrid,
  TeEngine,
  Series,
  TeeProcs,
  Chart,
  RzLabel,
  RzPanel,
  uMHA_SpecialResults,
  Dialogs;

type
  TfrmMHA_InstrumentResults = class(TForm)
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    N1: TMenuItem;
    mnuSelectPatient: TMenuItem;
    pnlHeader: TRzPanel;
    lblHeader: TRzLabel;
    pnlTop: TPanel;
    mnuTools: TMenuItem;
    mnuMetric: TMenuItem;
    mnuView: TMenuItem;
    mnuSaveAs: TMenuItem;
    mnuSaveReport: TMenuItem;
    mnuSaveTable: TMenuItem;
    mnuSaveGraph: TMenuItem;
    mnuPrint: TMenuItem;
    mnuPrintReport: TMenuItem;
    mnuPrintTable: TMenuItem;
    mnuPrintGraph: TMenuItem;
    N2: TMenuItem;
    mnuReports: TMenuItem;
    mnuGraphAndTable: TMenuItem;
    dlgSave: TSaveDialog;
    mnuComments: TMenuItem;
    N3: TMenuItem;
    mnuOptions: TMenuItem;
    lblPatient: TRzLabel;
    mnuEdit: TMenuItem;
    mnuCopy: TMenuItem;
    mnuCopyReport: TMenuItem;
    mnuCopyTable: TMenuItem;
    mnuCopyGraph: TMenuItem;
    mnuHelp: TMenuItem;
    mnuOnlineSupport: TMenuItem;
    N4: TMenuItem;
    mnuAbout: TMenuItem;
    mnuShowGraphLabels: TMenuItem;
    imgBackup: TImage;
    mnuPrintBlank: TMenuItem;
    PageControl1: TPageControl;
    tsReports: TTabSheet;
    pnlReportsOuter: TPanel;
    splReportV: TSplitter;
    memReport: TRichEdit;
    grpAdmins: TRzGroupBox;
    grdAdministrations: TAdvStringGrid;
    tsGraphs: TTabSheet;
    pnlGraphOuter: TPanel;
    spltHorizontal: TSplitter;
    chrtScores: TChart;
    Series3: TLineSeries;
    Series2: TLineSeries;
    Series1: TLineSeries;
    LineSeries1: TLineSeries;
    Series4: TLineSeries;
    Series5: TLineSeries;
    Series9: TLineSeries;
    Series10: TLineSeries;
    Series6: TLineSeries;
    Series7: TLineSeries;
    Series8: TLineSeries;
    Series11: TLineSeries;
    Series12: TLineSeries;
    grpScores: TRzGroupBox;
    grdScores: TAdvStringGrid;
    mnuDelete: TMenuItem;
    PopupMenu1: TPopupMenu;
    mnupopDelete: TMenuItem;
    mnupopAppend: TMenuItem;
    tsSpecialResults: TTabSheet;
    sbSummary: TScrollBox;
    pnlLeft: TPanel;
    pnlRight: TPanel;
    pnlSpacer1: TPanel;
    pnlSpacer2: TPanel;
    mnuSpecialReportWizard: TMenuItem;
    N5: TMenuItem;
    mnuSpecialResults: TMenuItem;
    N6: TMenuItem;

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ConfigureForm;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure PageControl1Change(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure grdAdministrationsClickCell(Sender: TObject; ARow,
      ACol: Integer);
    procedure grdScoresClickCell(Sender: TObject; ARow, ACol: Integer);
    procedure mnuMetricClick(Sender: TObject);
    procedure mnuSelectPatientClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuReportsClick(Sender: TObject);
    procedure mnuGraphAndTableClick(Sender: TObject);
    procedure mnuCopyReportClick(Sender: TObject);
    procedure mnuCopyGraphClick(Sender: TObject);
    procedure mnuSaveTableClick(Sender: TObject);
    procedure mnuPrintGraphClick(Sender: TObject);
    procedure mnuSaveGraphClick(Sender: TObject);
    procedure mnuCopyTableClick(Sender: TObject);
    procedure mnuPrintTblClick(Sender: TObject);
    procedure mnuCommentsClick(Sender: TObject);
    procedure mnuOptionsClick(Sender: TObject);
    procedure mnuViewClick(Sender: TObject);
    procedure grdAdministrationsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuPrintReportClick(Sender: TObject);
    procedure mnuSaveReportClick(Sender: TObject);
    procedure mnuOnlineSupportClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuShowGraphLabelsClick(Sender: TObject);
    procedure imgBackupClick(Sender: TObject);
    procedure UpdateAllDisplays;
    procedure mnuSpecialResultsClick(Sender: TObject);
    procedure mnuPrintBlankClick(Sender: TObject);

    procedure FormResize(Sender: TObject);
    procedure mnuCopyClick(Sender: TObject);
    procedure mnuFileClick(Sender: TObject);
    procedure grdAdministrationsMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure RemoveAdmin(aAdminID: string);
    procedure mnuDeleteClick(Sender: TObject);
    procedure mnuSpecialReportWizardClick(Sender: TObject);
  private
    { Private declarations }

    procedure InitMemReport;
    procedure InitGrdAdministrations;
    procedure InitChart(grp: Integer);
    procedure InitGrdScores;
    //procedure InitSpecialResults;
    procedure LoadPreviousTests;
    function DisplayReport: boolean;
    procedure DisplayScores;
    procedure DisplayGrid;
    function RemoveSpaces(aTitle: string): string;
    function GetScores: string;
    procedure GetDLLScores;
    procedure GraphScores(IsMultiScale: Boolean; aTitle: string);
    procedure GraphSingleScale(aTitle: string);
    procedure GraphSeveralScales(aTitle: string);
    procedure EnableMenus;
    function DetermineGroup(const aTitle: string): Integer;
    function GetXLabel(aScaleName: string): string;
    function GetItemIndex(aQuestionID, ChoiceID: string): string;
    function LoadInstrumentRecords: Boolean;
    //procedure mnuSpecialResultsWizardClick(Sender: TObject);
    //procedure sbSummaryResize(Sender: TObject);
    procedure UpdateClickSeries(Sender: TCustomChart;
      Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    function BuildSpecialResults: Boolean;
    procedure LoadSpecialResults;
    function DrawPtInfo: Integer;
    function DrawHSGraph(WhichOne: Integer;
      aSpecialResult: TSpecialResultInstrument): integer;
    function DrawGuide(WhichOne: Integer;
      aSpecialResult: TSpecialResultInstrument): integer;
    //procedure DrawPCLGuide(WhichOne: Integer);
    function DrawItems(WhichOne: Integer;
      aAdminID, aDate: string; aSpecialResult: TSpecialResultInstrument): integer;
    procedure ChangeAnswers(aTitle, aDate: string;
      WhichOne, WhichResult: integer);
    procedure ConvertGridToStringList(var List: TStringList);
    procedure LoadScoresFromDLL(InstrumentName, AnswerString: string);
    procedure ReadScoresFromDLLInstrument(aInstrumentName: string);
    function NeedsSpecialLegacy508Report(aInstrumentName: string): boolean;
    procedure PrintSpecialResults;
  public
    { Public declarations }
  end;

var
  frmMHA_InstrumentResults    : TfrmMHA_InstrumentResults;

implementation

uses
  Printers,
  uIA_Const,
  uMHA_Const,
  uMHA_Registry,
  uMHA_LocalFiles,
  uIA_GUIControl,
  uIA_Answer,
  uMHA_AResult,
  uIA_Scale,
  uIA_ScaleGroup,
  uMHA_GAF,
  uMHA_GAF_OPS,
  uMHA_Administration_OPS,
  uMHA_Result_OPS,
  uMHA_Report_OPS,
  uIA_Utils,
  fIA_Dialogs,
  uIA_Patient,
  uIA_Patient_OPS,
  uIA_ThisUser,
  uIA_Instrument,
  uIA_Question,
  fMHA_About,
  fMHA_Main,
  fMHA_AppendComments,
  fMHA_Print,
  fMHA_Options,
  fMHA_Options_508,
  fMHA_Progress,
  uMHA_Report_IO,
  uMHA_DM,
  uMHA_SpecialResults_OPS,
  fMHA_Print_Blank,
  fMHA_SpecialResultsWizard;

{$R *.DFM}

const
  lcSpace                     = '   ';
  lcSRDelimiter               : Char = '@';
  lcLabel                     : string = 'lbll';
  lcGroupBox                  : string = 'grb';
  lcPanel                     : string = 'pnl';
  lcLabelGuide                : string = 'lblgd';
  lcChart                     : string = 'crt';
  lcByDate                    : string = 'ByDate';
  lcView                      : string = '(To view another set of answers, click on the bar of the graph above.)';

var
  lvInitialize,
    lvIsFirstViewOfSummary,
    lvIsFirstViewOfGraph      : Boolean;

  lvDateColWidth,
    lvDigit                   : Integer;

  lvListOfResults             : TStringList;

  lvColorList                 : array[0..5] of TColor;
  lvChart                     : TChart;
  lvGroupBox                  : TGroupBox;
  lvPanel                     : TPanel;
  lvLabel                     : TLabel;
  lvDLLResults                : string;


procedure TfrmMHA_InstrumentResults.FormCreate(Sender: TObject);
begin
  lvInitialize := True;
  Position := poDesigned;
  lvIsFirstViewOfSummary := True;
  lvDigit := 5000; // Random large number; used to name labels

  // Keep Position out of ConfigureForm when ConfigureForm can be called
  // more than once with the form.

  lvColorList[0] := clOlive;
  lvColorList[1] := clSilver;
  lvColorList[2] := clBlack;
  lvColorList[3] := clSkyBlue;
  lvColorList[4] := clBlue;
  lvColorList[5] := clPurple;

  lvListOfResults := TStringList.Create;

  ConfigureForm;

  if not LocalFiles.Check_DLL_Version then // Does YS_MHA_AUX.dll exist on PC? Is it current?
  begin
    
    Halt;
  end;
end;

procedure TfrmMHA_InstrumentResults.FormShow(Sender: TObject);
begin
  UpdateAllDisplays;

  mnuMetric.Enabled := (DataBaseMode = dbVista);
  lvInitialize := False;

  if (not gvUseScreenReader) and
    (tsSpecialResults.TabVisible) and (gvStart = 5) then
    begin
      PageControl1.ActivePageIndex := 2;
      BuildSpecialResults;
      exit;
    end;

  frmMHA_Main.Hide;
  Screen.Cursor := crDefault;

  if gvUseScreenReader then
    ActiveControl := grpAdmins
  else
    ActiveControl := grdAdministrations;
end;


procedure TfrmMHA_InstrumentResults.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  gvResultWidth := Width;
  gvResultHeight := Height;

  MHA_Registry.SaveRegistry;

  frmMHA_Main.Visible := True;

  if lvListOfResults <> nil then
    lvListOfResults.Free;
end;


procedure TfrmMHA_InstrumentResults.ConfigureForm;
var
  i                           : Integer;
begin
  Caption := MHA_Caption + ' in use by ' + ThisUser.Name;
  MHA_Registry.ReadRegistry;
  with GUI_Control do
    begin
      Scaled := True;
      AutoScroll := False;
      AutoSize := False;
      PixelsPerInch := 120;

      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(gvFont);

      Height := GetHeight(gvResultHeight);
      Width := GetWidth(gvResultWidth);
      Left := GetLeft(Width);
      Top := GetTop(Height);
      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      Refresh; // resets alClient dimensions

      // Make sure the bottom tabs are visible
      if (Top + Height) > Screen.WorkAreaHeight then
        Top := Screen.WorkAreaHeight - Height;

      with memReport do
        begin
    // Use a fixed-width font for proper displays of graphs & reports.
    // See also DisplayReport where these attributes are restated.
          DefAttributes.Name := 'Courier New';
          DefAttributes.Size := gvFont.Size;
          DefAttributes.Color := gvFont.color;
          DefAttributes.Style := gvFont.style;

          if gvFont.size > 10 then
            ScrollBars := ssBoth
          else
            ScrollBars := ssVertical;
        end;

      for i := 0 to ComponentCount - 1 do
        begin
          if Components[i] is TLabel then
            begin
              TLabel(Components[i]).Font.Assign(gvFont);
              TLabel(Components[i]).Height := TextHeight('Yy', gvFont);
            end;

          if Components[i] is TGroupBox then
            Font.Assign(gvFont);

          if Components[i] is TChart then
            with TChart(Components[i]) do
              begin
                LeftAxis.LabelsFont.Assign(gvFont);
                LeftAxis.Title.Font.Assign(gvFont);
                BottomAxis.LabelsFont.Assign(gvFont);
                Title.Font.Assign(gvFont);
                Title.Font.Style := [fsBold];
              end;
        end; // for i

      pnlHeader.Height := pnlHeaderHeight;
      lblHeader.Font.Assign(gvFont);
      lblHeader.Font.Size := lblHeaderFontSize;
      lvDateColWidth := GUI_Control.TextWidth('XXX/XX/XXXXX', gvFont);

      pnlSpacer1.Width := 5; // left edge
      pnlSpacer2.Width := 5; // center
      sbSummary.VertScrollBar.Range := sbSummary.Height; // updated later

    end; // with GUI Control

  if gvUseScreenReader then
    begin
      Left := 0;
      Width := Screen.Width;
      imgBackup.Visible := False;
      chrtScores.Visible := False;
      spltHorizontal.Visible := False;
      tsSpecialResults.TabVisible := false;
      mnuSpecialReportWizard.Visible := false;
      mnuShowGraphLabels.Visible := false;

      grpAdmins.TabStop := True;
      grpScores.TabStop := True;
      Caption := 'Results for patient ' + Patient.Name;
    // Don't call this a "table." JAWS has special keys for reading tables
    // which will not work here.
      grpAdmins.Caption :=
        'The following grid has two columns: the date of administration' +
        ' and the name of the instrument. Navigate' +
        ' with the arrow keys, select with the enter key, then press tab key' +
        ' to read report. To enter grid press tab key.';
      grpScores.Caption := 'The next grid shows scale scores in two columns:' +
        ' the first is the date of administration, the second is the scale and' +
        ' its score. Navigate with the arrow keys. Enter grid with tab key. Press' +
        ' escape key when done.';
    end
  else
    begin
      grpAdmins.TabStop := False;
      grpScores.TabStop := False;
    end;
end;

procedure TfrmMHA_InstrumentResults.FormResize(Sender: TObject);
begin
  if lvInitialize then
    Exit;

  // Reset these, used in placement of dialogs
  gvLeft := Left;
  gvTop := Top;
  gvHeight := Height;
  gvWidth := Width;
end;


procedure TfrmMHA_InstrumentResults.InitMemReport;
begin
  with memReport do
    begin
      Lines.Clear;
      if not gvUseScreenReader then
        Lines.Add('Loading report...');
    end;
end;

procedure TfrmMHA_InstrumentResults.InitGrdAdministrations;
begin
  with grdAdministrations do
    begin
      Clear;
      RowCount := 2;
      ColCount := 4;
      Font.Assign(gvFont);
      DefaultRowHeight := 3 * (GUI_Control.TextHeight('Yy', gvFont))
        div 2;

      FixedFont.Assign(gvFont);
      FixedRowAlways := True;
      FixedRows := 1;
      FixedRowHeight := DefaultRowHeight;

      if gvUseScreenReader then
        begin
          SelectionRectangle := True;
          ShowSelection := True;
          Options := [goFixedVertLine, goFixedHorzLine, goHorzLine,
            goDrawFocusSelected, goColSizing, goRowSelect]
        end
      else
        begin
          grpAdmins.Caption := ' Instruments: ';
          SelectionRectangle := False;
          ShowSelection := True;
          Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
            goDrawFocusSelected, goColSizing, goRowSelect];
        end;

      DefaultColWidth := lvDateColWidth;
      ColWidths[2] := 0; //lvDateColWidth;
      ColWidths[3] := 0;
      Width := 2 * DefaultColWidth + 2;

      Cells[0, 0] := 'Date';
      Cells[1, 0] := 'Name';
      Cells[0, 1] := '';
      Cells[1, 1] := '';
    end;
end;

procedure TfrmMHA_InstrumentResults.UpdateAllDisplays;
begin
  Screen.Cursor := crHourglass; { Show hourglass cursor }
  lblPatient.Caption := Patient.CaptionInfo;

  PageControl1.ActivePageIndex := 0;
  EnableMenus;

  InitMemReport;
  InitGrdAdministrations;

  lvIsFirstViewOfGraph := True;
  lvIsFirstViewOfSummary := True;

  if (not gvUseScreenReader) then
    tsSpecialResults.TabVisible := NumberOfPieces(gvSpecialResultsList, U) > 0;

  Application.ProcessMessages;

  LoadPreviousTests; // if no results, Special results tab is turned off
  Screen.Cursor := crDefault;
  //tsGraphs.TabVisible := true;

  if (Result_OPS.ListOfResults.count < 1) then
    begin
      lblHeader.Caption :=
        '  Instrument Results Review: No previous test administrations found.';
      grdAdministrations.Cells[0, 1] := '';
      gvCurrentResult := 0;
      memReport.Clear;

      mnuSaveAs.Enabled := false;
      mnuPrint.Enabled := false;
      mnuEdit.Enabled := false;
      mnuView.Enabled := false;
      mnuComments.Enabled := false;
      tsGraphs.TabVisible := false;
      tsSpecialResults.TabVisible := false;

    end
  else
    begin
      if not gvUseScreenReader then
        grdAdministrations.OnClickCell(Self, 1, 0);

      mnuSaveAs.Enabled := true;
      mnuPrint.Enabled := true;
      mnuEdit.Enabled := true;
      mnuView.Enabled := true;
      mnuComments.Enabled := true;

    end;

//  if (tsSpecialResults.TabVisible) and (PageControl1.ActivePageIndex = 2) then
//    BuildSpecialResults;

end;

procedure TfrmMHA_InstrumentResults.LoadPreviousTests;
var
  i, x,
    TempWidth, MaxWidth       : integer;
  TempDate                    : TDateTime;
begin

  MaxWidth := grdAdministrations.ColWidths[0];
  x := 1;
  LoadInstrumentRecords;

  if Result_OPS.ListOfResults.Count = 0 then
    begin
      grdAdministrations.RowCount := 2;
      tsSpecialResults.TabVisible := false;
    end;

  for i := 0 to Result_OPS.ListOfResults.Count - 1 do
    begin
      // Use the date only
      TempDate := StrToDateTime(TAResult(Result_OPS.ListOfResults[i]).DateGiven);
      grdAdministrations.Cells[0, x] := FormatDateTime('mm/dd/yyyy', TempDate);
      grdAdministrations.Cells[1, x] := TAResult(Result_OPS.ListOfResults[i]).InstrumentName;
      grdAdministrations.Cells[2, x] := TAResult(Result_OPS.ListOfResults[i]).AdministrationIENS;

      // Legacy
      grdAdministrations.Cells[3, x] := InttoStr(TAResult(Result_OPS.ListOfResults[i]).TESTIENS);

      // Find widest instrument name
      TempWidth := GUI_Control.TextWidth(TAResult(Result_OPS.ListOfResults[i]).InstrumentName + 'XXX',
        grdAdministrations.Font);
      if TempWidth > MaxWidth then
        MaxWidth := TempWidth;
      Inc(x);
    end; //for i...

  grdAdministrations.ColWidths[1] := MaxWidth;
  grdAdministrations.RowCount := x;

  grpAdmins.Width := grdAdministrations.ColWidths[0] + MaxWidth +
    grdAdministrations.ScrollWidth;

  // This handles the very rare case where there is one admin, but it is without an Admin ID
  if grdAdministrations.RowCount = 1 then
    tsSpecialResults.TabVisible := false;
end;


procedure TfrmMHA_InstrumentResults.InitChart(grp: Integer);
var
  i                           : integer;
begin

  //clear the chart
  with chrtScores do
    begin
      Legend.Visible := False;
      Legend.FirstValue := 0;
      with LeftAxis do
        begin
          AutomaticMaximum := False;
          Minimum := -1;
          Maximum := 1;

          for i := 0 to 12 do
            begin
              SeriesList.Series[i].Clear;
              SeriesList.Series[i].Active := False;
            end;

          if Result_OPS.ListOfScaleGroups.Count = 0 then // Legacy, set defaults
            begin
              AutomaticMaximum := True;
              Maximum := 0;
              Minimum := 0;
              increment := 1;
              Title.Caption := 'Score';
              Exit;
            end;

          Maximum := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).OrdinateMax;
          if Maximum = -1 then
            AutomaticMaximum := True;
          // This improves the readability of the graph
          //if TAResult(Result_OPS.ListOfResults[grp]).AnswersAreInLegacyFile then
            Maximum := Maximum + 1;
          if TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).OrdinateMin <= Maximum then
            Minimum := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).OrdinateMin;
          // This improves the readability of the graph
          //if TAResult(Result_OPS.ListOfResults[grp]).AnswersAreInLegacyFile then
            Minimum := Minimum - 1;
            
          Title.Caption := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).OrdinateTitle;
          if TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).OrdinateIncrement = -1 then
            increment := 1
          else
            Increment := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).OrdinateIncrement;
        end; //with LeftAxis

    end; //with chrtTestGraph
end;


procedure TfrmMHA_InstrumentResults.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_InstrumentResults.mnuSelectPatientClick(
  Sender: TObject);
var
  OldDFN                      : string;
  Save_Cursor                 : TCursor;
begin
  // This form is used only if DataBaseMode = dbVista,
  // so selecting an offline patient using fMHA_SelectPatient
  // is not needed.

  OldDFN := Patient.DFN;

  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;
  try
    Patient_OPS.SelectUsingCPRS;
  finally
    Screen.Cursor := Save_Cursor; { Always restore to normal }
  end;

  if not (OldDFN = Patient.DFN) then
    UpdateAllDisplays;
end;


procedure TfrmMHA_InstrumentResults.EnableMenus;
begin
  // Report Tab Active
  mnuReports.Enabled := (PageControl1.ActivePageIndex <> 0);

  // Graph/Table Tab Active
  mnuGraphAndTable.Enabled := (PageControl1.ActivePageIndex <> 1) and
    tsGraphs.TabVisible = True;

  // Go to Special Results Tab
  mnuSpecialResults.Enabled := (PageControl1.ActivePageIndex <> 2) and
    (tsSpecialResults.TabVisible);

  mnuSaveReport.Enabled := not mnuReports.Enabled;
  mnuCopyReport.Enabled := mnuSaveReport.Enabled;
  mnuDelete.Enabled := mnuSaveReport.Enabled;
  mnuComments.Enabled := mnuSaveReport.Enabled;
  mnuMetric.Enabled := (PageControl1.ActivePageIndex <> 2);

  mnuSaveGraph.Enabled := (PageControl1.ActivePageIndex = 1) and
    tsGraphs.TabVisible = True;
  mnuPrintGraph.Enabled := mnuSaveGraph.Enabled;
  mnuCopyGraph.Enabled := mnuSaveGraph.Enabled;

  mnuSaveTable.Enabled := mnuSaveGraph.Enabled;
  mnuPrintTable.Enabled := mnuSaveGraph.Enabled;
  mnuCopyTable.Enabled := mnuSaveGraph.Enabled;

  if mnuSaveGraph.Enabled then
    begin
      mnuPrintReport.Enabled := False;
      mnuPrintReport.Caption := '&Report';
    end;

  mnuSpecialResults.Enabled := (PageControl1.ActivePageIndex <> 2) and
    tsSpecialResults.TabVisible;

  if (PageControl1.ActivePageIndex = 0) then
    begin
      mnuPrintReport.Enabled := true;
      mnuPrintReport.Caption := '&Report';
    end;

  if (PageControl1.ActivePageIndex = 2) then
    begin
      mnuPrintReport.Enabled := true;
      mnuPrintReport.Caption := 'Special &Results';
    end;
end;


procedure TfrmMHA_InstrumentResults.PageControl1Change(Sender: TObject);
begin

  EnableMenus;

  if (PageControl1.ActivePageIndex = 1) and
    lvIsFirstViewOfGraph then
    begin
      Screen.Cursor := crHourglass;
      Application.ProcessMessages;

      DisplayScores;
      Screen.Cursor := crDefault;
      lvIsFirstViewOfGraph := False;
    end;

  if (PageControl1.ActivePageIndex = 2) then
    begin
      lblHeader.Caption := '  Special Results';
      if lvIsFirstViewOfSummary then
        BuildSpecialResults;
    end
    else
    lblHeader.Caption := '  Instrument Results Review: ' +
        TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName;
end;


procedure TfrmMHA_InstrumentResults.PageControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  AllowChange := True;

  if (PageControl1.ActivePageIndex = 0) then
    AllowChange := TAResult(Result_OPS.ListOfResults[gvCurrentResult]).UserHasPermissionToView;
end;

procedure TfrmMHA_InstrumentResults.DisplayGrid;
// Alternative for screen readers.
var
  i, j, arow                  : integer;
  TempStr,
    TempStr1                  : string;
begin

  with grdScores do
    begin
      Clear;
      Font.Assign(gvFont);

      SelectionRectangle := True;
      ShowSelection := True;
      Options := [goHorzLine, goDrawFocusSelected, goColSizing, goRowSelect];
      FixedRowAlways := False;
      FixedColAlways := False;
      FixedRows := 0;
      FixedCols := 0;
      ShowHint := False;
      ColCount := 2;
      ColWidths[0] := lvDateColWidth;

      // The order of the instruments can be changed by user: synch with ListOfResults
      for i := 0 to Result_OPS.ListOfResults.Count - 1 do
        if grdAdministrations.Cells[2, grdAdministrations.Row] =
          TAResult(Result_OPS.ListOfResults[i]).AdministrationIENS then
          begin
            gvCurrentResult := i;
            break;
          end;

      arow := 0;
      for i := 0 to Result_OPS.ListOfResults.Count - 1 do
        begin
          if TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName =
            TAResult(Result_OPS.ListOfResults[i]).InstrumentName then
            begin
              TAResult(Result_OPS.ListOfResults[i]).ListOfScores := Result_OPS.LoadScores(
                TAResult(Result_OPS.ListOfResults[i]).AnswersAreInLegacyFile,
                TAResult(Result_OPS.ListOfResults[i]).AdministrationIENS,
                TAResult(Result_OPS.ListOfResults[i]).InstrumentName,
                Patient.DFN,
                TAResult(Result_OPS.ListOfResults[i]).DateSaved);

              for j := 1 to NumberOfPieces(TAResult(Result_OPS.ListOfResults[i]).ListOfScores,
                Record_End) do
                begin

                  TempStr := Piece(TAResult(Result_OPS.ListOfResults[i]).ListOfScores, Record_End, j);

                  TempStr1 := Piece(TempStr, EQ, 2);

                  if NumberOfPieces(TempStr1, U) > 0 then
                    TempStr1 := Piece(TempStr1, U, 2);
                  if TempStr1 = '' then
                    TempStr1 := Piece(Piece(TempStr, EQ, 2), U, 1);
                  grdScores.Cells[0, arow] := TAResult(Result_OPS.ListOfResults[i]).DateSaved;
                  grdScores.Cells[1, arow] := Piece(TempStr, EQ, 1) + ' ' +
                    TempStr1;
                  Inc(arow);
                end; // for j

            end; // This instrument
        end; // for i

      RowCount := arow;
      ColumnSize.Stretch := True;
    end; //with grdScores
end;

procedure TfrmMHA_InstrumentResults.DisplayScores;
var
  i                           : integer;
  TempStr                     : string;
begin
  lvDLLResults := '';

  if gvUseScreenReader then
    begin
      DisplayGrid;
      ActiveControl := grpScores;
      Exit;
    end;

  if Result_OPS.LoadScaleGroupsAndScales(TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName) = BAD_DATA then //uMHA_Scales_IO
    begin
      ShowMessage('Unable to read scales.');
      Exit;
    end;

  InitGrdScores; // Build the grid's rows with scale names

  // This is a quick check to see if the instrument uses the dll
  // Returns lvDLLResults = 'YES' or 'NO'
  LoadScoresFromDLL(
    TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName,
    TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName);

  // ---- Instruments scored in DLL ----
  if lvDLLResults = YES then
    begin
      // lvDLLResults is now in format: #=Text^#=text
      ReadScoresFromDLLInstrument(TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName);
      GetDLLScores;
    end
  else
    begin
      TempStr := GetScores; // Populates Result_OPS.ListOfResults[gvCurrentResult].ListOfScores

      // Returns "OK" with proper functioning
      if Pos(BAD_DATA, TempStr) > 0 then
        begin
          ShowMessage('Unable to read scores: ' + #13 + TempStr);
        end;
    end;

  TAResult(Result_OPS.ListOfResults[gvCurrentResult]).IsMultiScale :=
    Result_OPS.ListOfScales.Count > 1;

  InitChart(0);

  if TAResult(Result_OPS.ListOfResults[gvCurrentResult]).IsMultiScale then
    begin
      grdScores.ShowHint := true;

      // Make all the dates bold
      for i := 1 to grdScores.ColCount do
        grdScores.FontStyles[i, 0] := [fsBold];

      // MMPI2: Show Clinical scales as first scale group
      if TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName = 'MMPI2' then
        begin
          for i := 1 to grdScores.RowCount do
            grdScores.FontStyles[0, i] := [];
          grdScores.FontStyles[0, 16] := [fsBold];
          grdScores.SelectRows(16, 1);
        end
      else
        begin
          grdScores.FontStyles[0, 1] := [fsBold];
          grdScores.Row := 1;
        end;

      GraphScores(True, lcByDate);
    end
  else
    begin
      grdScores.ShowHint := false;
      GraphScores(False, {title} grdscores.cells[0, 1]);
    end;
end;

function TfrmMHA_InstrumentResults.RemoveSpaces(aTitle: string): string;
var
  i                           : Integer;

begin
  Result := aTitle;
  i := 1;
  while i < Length(Result) do
    begin
      if Result[i] = ' ' then
        Delete(Result, i, 1);
      if Result[i] = '-' then
        Delete(Result, i, 1);
      Inc(i)
    end;
end;

function TfrmMHA_InstrumentResults.GetXLabel(aScaleName: string): string;
var
  i                           : Integer;
begin
  Result := '';

  for i := 0 to Result_OPS.ListOfScales.Count - 1 do

    if TScale(Result_OPS.ListOfScales[i]).ScaleName = aScaleName then
      begin
        result := TScale(Result_OPS.ListOfScales[i]).xLabel;
        if result = '' then
          result := Copy(aScaleName, 1, 3);
        break;
      end;
end;


function TfrmMHA_InstrumentResults.DetermineGroup(const aTitle: string): Integer;
var
  i, j                        : Integer;
  TempTitle,
    TempIEN                   : string;
begin
  result := -1;

  if not TAResult(Result_OPS.ListOfResults[gvCurrentResult]).IsMultiScale then
    begin
      result := 0;
      Exit;
    end;

  TempTitle := Trim(aTitle);
  for i := 0 to Result_OPS.ListOfScaleGroups.Count - 1 do
    if TempTitle = TScaleGroup(Result_OPS.ListOfScaleGroups[i]).GroupName then
      begin
        result := i;
        Exit;
      end;

  for i := 0 to Result_OPS.ListOfScales.Count - 1 do
    if CompareStr(TempTitle, TScale(Result_OPS.ListOfScales[i]).ScaleName) = 0 then
      begin
        TempIEN := TScale(Result_OPS.ListOfScales[i]).GroupIEN;
        for j := 0 to Result_OPS.ListOfScaleGroups.Count - 1 do
          if TempIEN = TScaleGroup(Result_OPS.ListOfScaleGroups[j]).IEN then
            begin
              result := j;
              Exit;
            end;
      end;
end;


procedure TfrmMHA_InstrumentResults.GraphScores(IsMultiScale: Boolean;
  aTitle: string);
begin

  if gvUseScreenReader then
    Exit;

  if IsMultiScale then
    GraphSeveralScales(aTitle)
  else
    GraphSingleScale(aTitle);

end;


procedure TfrmMHA_InstrumentResults.GraphSeveralScales(aTitle: string);
var
  grp, i, j,
    StartHere, c,
    icol, irow,
    iseries                   : integer;
  ordinate                    : double;
  MyColor                     : TColor;
  TempStr, TempStr1,
    xlabel, CellValue         : string;

  procedure DrawGridLines(XValue: integer; XLabel: string);
  var
    DrawGrid                  : BOOLEAN;
    GridOrdinate              : array[0..2] of integer;
    ii                        : integer;
  begin

    GridOrdinate[0] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid1Ordinate;
    GridOrdinate[1] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid2Ordinate;
    GridOrdinate[2] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid3Ordinate;

    for ii := 0 to 2 do
      begin
        DrawGrid := (GridOrdinate[ii] > -1);
        chrtScores.SeriesList.Series[ii].Active := DrawGrid;

        if DrawGrid then
          chrtScores.SeriesList.Series[ii].AddXY(XValue, GridOrdinate[ii],
            Xlabel, clBlack);
      end;
  end;


begin
  StartHere := grdScores.Row;

  with chrtScores do
    begin
      if aTitle = lcByDate then
        begin
          if grdScores.ColCount < 2 then
            Exit;

          // Get first group-scale info
          TempStr := '';

          for i := StartHere to grdScores.RowCount do
            begin
              if grdScores.FontStyles[0, i] = [fsBold] then
                begin

                  TempStr := grdScores.Cells[0, i];

                  if TempStr[1] <> ' ' then
                    begin
                      Title.Text.Text := TempStr;
                      //grdScores.FontStyles[0, i] := [fsBold];
                      //EndHere := i;
                      Break;
                    end;
                end;
            end; // for i
          //if EndHere < 2 then
          //  EndHere := grdScores.RowCount;

          if TempStr <> '' then
            begin
              grp := DetermineGroup(TempStr);
              if grp = -1 then
                begin
                  ShowMessage('Unable to determine the Scale-Group.');
                  Exit;
                end;

              iseries := 3; // Grid lines are 0,1,2
              InitChart(grp);
              Legend.Visible := True;

              for c := 1 to grdScores.ColCount - 1 do
                begin

                  if grdScores.FontStyles[c, 0] = [fsBold] then
                    begin

                      SeriesList.Series[iseries].Active := True;
                      MyColor := SeriesList.Series[iseries].SeriesColor;
                      // Date
                      SeriesList.Series[iseries].Title :=
                        grdScores.Cells[c {Col}, 0 {Row}];

                      for i := StartHere + 1 to grdScores.RowCount do
                        begin
                          TempStr1 := grdScores.Cells[0, i];

                          if Length(Tempstr1) > 1 then
                            begin
                              if TempStr1[1] = ' ' then // A scale name
                                begin

                                  CellValue := Trim(grdScores.Cells[c, i]);
                                  if (CellValue = '') or (CellValue = ' ') then
                                    CellValue := '0';

                                  // Be sure the cell contains an integer
                                  for j := 1 to Length(CellValue) do
                                    if not (CellValue[j] in ['0'..'9', '.', '-']) then
                                      Exit;

                                  if POS('.', CellValue) > 0 then // Real
                                    begin
                                      //ordinate := Round(StrToFloat(CellValue))
                                      ordinate := StrToFloat(CellValue);
                                      FormatFloat('#,##0.00', ordinate);
                                    end
                                  else
                                    ordinate := StrToInt(CellValue);

                                  // Scale name to XLabel
                                  xlabel := GetXLabel(Trim(TempStr1));

                                  SeriesList.Series[iseries].AddXy(i, ordinate,
                                    xLabel, MyColor);
                                end
                              else
                                break;
                            end; // If a scale

                        end; // for i

                    end; // bold

                  Inc(iseries);
                  if iseries = 13 then
                    Exit;
                end; // for c
            end; //  TempStr not blank
        end // ByDate
      else
        // Group Scale Name
        begin

          iseries := 3;

          irow := grdScores.Row;

          SeriesList.Series[iseries].Active := True;
          MyColor := SeriesList.Series[iseries].SeriesColor;

          for icol := 1 to grdScores.ColCount do //Scale_List.NumberOfDates  do
            begin
              CellValue := Trim(grdScores.Cells[icol, irow]);
              if (CellValue = '') or (CellValue = ' ') then
                CellValue := '0';

              // Be sure the cell contains an integer
              for j := 1 to Length(CellValue) do
                if not (CellValue[j] in ['0'..'9', '.', '-']) then
                  Exit;

              if POS('.', CellValue) > 0 then // Real
                begin
                  //ordinate := Round(StrToFloat(CellValue))
                  ordinate := StrToFloat(CellValue);
                  FormatFloat('#,##0.00', ordinate);
                end
              else
                ordinate := StrToInt(CellValue);

               //Date
              xlabel := Trim(grdScores.Cells[icol, 0]);

              SeriesList.Series[iseries].AddXy(icol, ordinate,
                xLabel, MyColor);

              DrawGridLines(icol, xlabel);
            end; // for irow loop
        end; //group name is not selected
    end; // with ChartScores
end;


procedure TfrmMHA_InstrumentResults.GraphSingleScale(aTitle: string);
var
  i, j, grp                   : Integer;
  ordinate                    : double;
  CellValue                   : string;

  procedure DrawGridLines;
  var
    GridOrdinate              : array[0..2] of integer;
    ii, jj                    : integer;
  begin

    GridOrdinate[0] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid1Ordinate;
    GridOrdinate[1] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid2Ordinate;
    GridOrdinate[2] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid3Ordinate;

    for ii := 0 to 2 do
      begin
        if (GridOrdinate[ii] > -1) then
          begin
            chrtScores.SeriesList.Series[ii].Active := true;

            for jj := 1 to grdScores.ColCount - 1 do
              chrtScores.SeriesList.Series[ii].AddXY(
                StrToDateTime(grdScores.Cells[jj, 0]),
                GridOrdinate[ii],
                grdScores.Cells[jj, 0],
                clBlack);
          end
        else
          chrtScores.SeriesList.Series[ii].Active := False;
      end;
  end;

begin

  if Result_OPS.ListOfScaleGroups.Count = 0 then
    grdScores.row := 1
  else
    begin
      grdScores.row := 2;
      grp := DetermineGroup(aTitle);

      if grp = -1 then
        begin
          ShowMessage('Unable to determine the Scale-Group.');
          Exit;
        end;

      InitChart(grp);
    end;

  with chrtScores do
    begin
      Legend.Visible := False;
      Title.Text.Text := aTitle;
      SeriesList.Series[3].Active := True;

      for i := 1 to grdScores.ColCount - 1 do
        begin
          grdScores.FontStyles[i, 0] := [];

          CellValue := grdScores.Cells[i, grdScores.row];

          if (CellValue = '') or (CellValue = ' ') then
            CellValue := '0';

           // Be sure the cell contains an integer
          for j := 1 to Length(CellValue) do
            if not (CellValue[j] in ['0'..'9', '.', '-']) then
              Exit;

          if POS('.', CellValue) > 0 then // Real
            begin
              //ordinate := Round(StrToFloat(CellValue))
              ordinate := StrToFloat(CellValue);
              FormatFloat('#,##0.00', ordinate);
            end
          else
            ordinate := StrToInt(CellValue);

          SeriesList.Series[3].AddXY(StrToDateTime(grdScores.Cells[i, 0]),
            ordinate,
            grdScores.Cells[i, 0], clred);
        end;
    end; //with chrtScores

  if Result_OPS.ListOfScaleGroups.Count <> 0 then
    DrawGridLines;
end;

procedure TfrmMHA_InstrumentResults.InitGrdScores;
// Screen readers will have a different table configuration.
var
  arow, i, j                  : Integer;

begin

  with grdScores do
    begin
      Clear;
      Font.Assign(gvFont);

      DefaultRowHeight := 3 * (GUI_Control.TextHeight('Yy', gvFont))
        div 2;
      grpScores.Caption := ' Scores ';

      SelectionRectangle := False;
      ShowSelection := True;
      Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
        goDrawFocusSelected, goRowSelect]; //goColSizing,
      FixedFont.Assign(gvFont);
      FixedRowAlways := True;
      FixedColAlways := True;
      FixedRows := 1;
      FixedCols := 1;
      FixedRowHeight := DefaultRowHeight;
      FixedColWidth := lvDateColWidth;
      SelectionColor := clHighlight;
      SelectionTextColor := clHighlightText;
      ShowHint := True;
      // This number is too large, it will be lowered later when the actual
      // number of dates are known.
      ColCount := Result_OPS.ListOfResults.Count + 1;
      ColWidths[0] := (5 * lvDateColWidth) div 2;
      SelectionColor := clWindow;
      SelectionTextColor := clWindowText;
      ColumnSize.Stretch := False;

      if Result_OPS.ListOfScaleGroups.Count = 0 then // Legacy results
        begin
          RowCount := 2;
          Exit;
        end;

      RowCount := Result_OPS.ListOfScales.Count + Result_OPS.ListOfScaleGroups.Count + 10;
      arow := 1;

      if Result_OPS.ListOfScaleGroups.Count > 1 then
        begin

          for i := 0 to Result_OPS.ListOfScaleGroups.Count - 1 do
            begin
              FontStyles[0, arow] := [fsBold];
              Cells[0, arow] := TScaleGroup(Result_OPS.ListOfScaleGroups[i]).GroupName;
              inc(arow);
              for j := 0 to Result_OPS.ListOfScales.Count - 1 do
                begin
                  if (TScale(Result_OPS.ListOfScales[j]).GroupIEN =
                    TScaleGroup(Result_OPS.ListOfScaleGroups[i]).IEN) then
                    begin
                      FontStyles[0, arow] := [];
                      Cells[0, arow] := lcSpace + TScale(Result_OPS.ListOfScales[j]).ScaleName;
                      inc(arow);
                    end;
                end;
            end;
        end
      else
        begin
          FontStyles[0, 1] := [fsBold];
          Cells[0, arow] := TScaleGroup(Result_OPS.ListOfScaleGroups[0]).GroupName;
          inc(arow);
          for j := 0 to Result_OPS.ListOfScales.Count - 1 do
            begin
              Cells[0, arow] := ' ' + TScale(Result_OPS.ListOfScales[j]).ScaleName;
              inc(arow);
            end;
        end;
      RowCount := arow;
    end; //with grdScores
end;


function TfrmMHA_InstrumentResults.DisplayReport: boolean;
var
  i                           : Integer;
  InstName,
    AnswerString,
    ResultString              : string;
  ReportStrList               : TStringList;
  dllHandle                   : THandle;
  TempDate                    : TDateTime;

  procedure HandleGroomedAnswers;
  var
    ii                        : Integer;
    TempStr                   : string;
  begin
    // AnswerString format:
    // QuestionID=ItemIndex^AnswerText^AnswerID

    for ii := 0 to MHA_Report_OPS.ListOfAnswersForReport.Count - 1 do
      AnswerString := AnswerString +
        TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).QuestionID + EQ +
        GetItemIndex(TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).QuestionID,
        TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue) + U +
        TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue + U +
        TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerID +
        RECORD_END;

    if Assigned(GroomAnswersDLL) then
      GroomAnswersDLL(
        TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName,
        Patient.Name,
        Patient.DOB,
        Patient.Sex,
        AnswerString,
        ResultString);

    if (ResultString = '') or
      (ResultString = AnswerString) then
      begin
        ResultString := '';
        Exit;
      end
    else
      begin
        // Place new answer values in current list of answer values.
        AnswerString := '';
        for ii := 0 to MHA_Report_OPS.ListOfAnswersForReport.Count - 1 do
          begin
            TempStr := Piece(ResultString, RECORD_END, i);

            TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue :=
              Piece(Piece(TempStr, EQ, 2), U, 1);
            TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerText :=
              Piece(Piece(TempStr, EQ, 2), U, 2);

            AnswerString := AnswerString +
              TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).QuestionID + EQ +
              GetItemIndex(TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).QuestionID,
              TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue) + U +
              TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue + U +
              TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerID + RECORD_END;
          end;
      end; // else
  end;

begin
  result := true;
  memReport.Hide;
  AnswerString := '';
  ResultString := '';

//--- Legacy tests, entered with MHA2 ----
// These results do not have AdministrationIENS, Col 2 (unseen by user).
  if grdAdministrations.Cells[2, grdAdministrations.Row] = '' then
    begin
      // Look for TestIEN in Col 3 (unseen by user).
      if grdAdministrations.Cells[3, grdAdministrations.Row] = '' then
        begin
          Screen.Cursor := crDefault;
          pnlReportsOuter.caption := '                 No results to display.';
          MsgDlgFrm('The results of this legacy instrument cannot be accessed. ' + #13 +
            'The testIEN is missing.  ',
            MHA_CAPTION, mtInformation, [mbOK], 0);
          tsGraphs.TabVisible := false;
          result := false;
        end;

       // The order of the instruments can be changed by user: synch with ListOfResults
      for i := 0 to Result_OPS.ListOfResults.Count - 1 do
        begin
          TempDate := StrToDateTime(TAResult(Result_OPS.ListOfResults[i]).DateGiven);

          if (TAResult(Result_OPS.ListOfResults[i]).AdministrationIENS = '') and
            (grdAdministrations.Cells[3, grdAdministrations.Row] =
            IntToStr(TAResult(Result_OPS.ListOfResults[i]).TestIENS)) and
            (FormatDateTime('mm/dd/yyyy', TempDate) =
            grdAdministrations.Cells[0, grdAdministrations.Row]) then
            begin
              gvCurrentResult := i;
              break;
            end;
        end;

//--- end of Legacy tests, entered with MHA2 ----
    end
  else
//--- MHA3 entered instruments, legacy and non-legacy. Also instruments entered
//       from Clinical Reminders in CPRS with YS_MHA_A.dll.
//       These administrations do have an AdministrationIENS.
    begin

     // The order of the instruments can be changed by user: synch with ListOfResults
      for i := 0 to Result_OPS.ListOfResults.Count - 1 do
        if grdAdministrations.Cells[2, grdAdministrations.Row] =
          TAResult(Result_OPS.ListOfResults[i]).AdministrationIENS then
          begin
            gvCurrentResult := i;
            break;
          end;
    end;

  with TAResult(Result_OPS.ListOfResults[gvCurrentResult]) do
    begin

      // This will find out if the instrument has any scales:
      // Don't show graph Tab if without scales.

      ListOfScores := Result_OPS.LoadScores(
        AnswersAreInLegacyFile, AdministrationIENS,
        InstrumentName, Patient.DFN, DateSaved);

      if NumberOfPieces(ListOfScores, EQ) = 0 then
        begin
          Kind := irNoScales;
          tsGraphs.TabVisible := false;
        end
      else
        begin
          tsGraphs.Caption := '&Graph && Table';
          tsGraphs.TabVisible := True;
        end;

      lblHeader.Caption := '  Instrument Results Review: ' + InstrumentName;

      InitMemReport;
      Application.ProcessMessages;
      //So the header caption will resize in a timely manner

      if not UserHasPermissionToView then
        begin
          memReport.Show;
          memReport.Clear;
          memReport.Text := '  This is a restricted report.';
          tsGraphs.TabVisible := false;
          Exit;
        end;

      if AdministrationIENS <> '' then // MHA3 entry
        begin

          // Load question test, answer text, etc.
          if not MHA_Report_OPS.BuildAllReportLists(InstrumentName,
            AdministrationIENS) then
            Exit;

       	  // patch 105 added gvAuxFile which = proper C:\Program Files dir for the YS_MHA_AUX file llh
          dllHandle := LoadLibrary(PChar(gvAuxFile));

          if dllHandle = 0 then
            begin
              // patch 105 added gvAuxFile, removed C:\Program Files llh
              MsgDlgFrm('Could not find DLL used for displaying instruments.' +
                'The file YS_MHA_AUX.DLL is usually located in ' + gvAuxFile , MHA_CAPTION,
                mtWarning, [mbOk], 0)
            end
          else
            begin
              try
                @GroomAnswersDLL := GetProcAddress(dllHandle, 'GroomAnswers');

                if @GroomAnswersDLL = nil then
             // function not found, continue below
                else
                  HandleGroomedAnswers;
              finally
                FreeLibrary(dllHandle);
              end; {try..finally}
            end; // if dllHandle

       	  // patch 105 added gvAuxFile which = proper C:\Program Files dir for the YS_MHA_AUX file llh
          dllHandle := LoadLibrary(PChar(gvAuxFile));

      // Check for hard coded scoring to add to report
          if dllHandle = 0 then // do nothing
          else
            begin
              try
                @ProgressNoteDLL := GetProcAddress(dllHandle, 'ProgressNote');

                if @ProgressNoteDLL = nil then //do nothing
                else
                  begin
                    if gvUseScreenReader then
                      InstName := InstrumentName + '-SR'
                    else
                      InstName := InstrumentName;

                    if Assigned(ProgressNoteDLL) then
                      ProgressNoteDLL(InstName,
                        Patient.Name,
                        Patient.DOB,
                        Patient.Sex,
                        AnswerString,
                        ResultString);
                  end; //else
              finally
                FreeLibrary(dllHandle);
              end; {try..finally}
            end; // else
        end; // MHA3 entry

      ReportStrList := TStringList.create;

      // Handle the special cases with 508
      if gvUseScreenReader and NeedsSpecialLegacy508Report(InstrumentName) then
        begin
          if MHA_Report_OPS.Load508LegacyReport(
            InstrumentName,
            AdministrationIENS,
            Patient.DFN,
            AdminBy,
            OrderedBy,
            Location, // locationIEN
            DateGiven,
            DateSaved,
            TestIENS,
            AnswersAreInLegacyFile,
            ReportStrList) = 'ERROR' then
            begin
              MsgDlgFrm('An error has occured while generating this report.',
                MHA_CAPTION, mtError, [mbOK], 0);
              ReportStrList.Free;
              Exit;
            end;
        end
      else
        begin
        // This returns the complete report as a string list.
        // LoadReport will get the template for the report (this was created in
        // Instrument Authoring Tool) and the answers, scores, scripts, etc. will
        // be filled in as neededfor this administration.
          if MHA_Report_OPS.LoadReport(
            InstrumentName,
            AdministrationIENS,
            AdminBy,
            OrderedBy,
            Location, // locationIEN
            DateGiven,
            DateSaved,
            TestIENS,
            False, // ForceWrap; Used for progress notes
            Kind = irLegacy,
            WriteFullText,
            ResultString,
            ReportStrList) = 'ERROR' then
            begin
              MsgDlgFrm('An error has occured while generating this report.',
                MHA_CAPTION, mtError, [mbOK], 0);
              ReportStrList.Free;
              Exit;
            end;
        end;

      // Build and tweek the memo that contains the report.
      with memReport do
        begin
          Clear;
          Lines.AddStrings(ReportStrList);
          //Lines.Add(ResultString);

          if Kind = irLegacy then
            begin
              // remove excessive blank lines
              Text := StringReplace(Text, #13#10#13#10#13#10, #13,
                [rfReplaceAll, rfIgnoreCase]);
              Text := StringReplace(Text, #13#13#13, #13,
                [rfReplaceAll, rfIgnoreCase]);
              Text := StringReplace(Text, #13#13#13, #13,
                [rfReplaceAll, rfIgnoreCase]);
            end;

          Font.Name := 'Courier New';
          // patch 105 llh - if instrument is the MMPI2-RF then force the font size to 11
          if (InstName = 'MMPI-2-RF') then
            Font.Size := 11
          else
            Font.Size := gvFont.Size;

          Font.Color := gvFont.color;
          Font.Style := gvFont.style;
          MaxLength := Length(Text);
        end; // with MemReport

      ReportStrList.Free;

      // Go to the top of the report.
      for i := 0 to 12 do
        SendMessage(memReport.Handle, WM_VSCROLL, SB_PAGEUP, 0);

      memReport.Show;

    end; // TAResult(Result_OPS.ListOfResults[gvCurrentResult])
end;

function TfrmMHA_InstrumentResults.GetItemIndex(aQuestionID, ChoiceID: string): string;
var
  j, i                        : Integer;
begin
  result := ChoiceID;

  if (ChoiceID = NOT_ASKED) or (ChoiceID = SKIPPED) or
    (ChoiceID = CHOICE_ID_OF_SKIPPED_QUESTION) or
    (ChoiceID = CHOICE_ID_OF_SKIPPED_BY_RULE_QUESTION) or
    (ChoiceID = CHOICE_ID_OF_SKIPPED_REQUIRED_QUESTION) then
    Exit;

  for i := 0 to MHA_Report_OPS.ListOfQuestionsForReport.Count - 1 do
    if aQuestionID = TQuestion(MHA_Report_OPS.ListOfQuestionsForReport[i]).QuestionID then
      if TQuestion(MHA_Report_OPS.ListOfQuestionsForReport[i]).ResponseType = rtMultiChoice then
        for j := 0 to TQuestion(MHA_Report_OPS.ListOfQuestionsForReport[i]).MultiChoice.choices.Count - 1 do
          if Piece(TQuestion(MHA_Report_OPS.ListOfQuestionsForReport[i]).MultiChoice.choices[j], U, 2) =
            ChoiceID then
            result := IntToStr(j);
end;

procedure TfrmMHA_InstrumentResults.grdAdministrationsClickCell(
  Sender: TObject; ARow, ACol: Integer);
begin
  pnlReportsOuter.caption := '                 Loading ...';
  if (ARow > 0) then
    begin
      gvCurrentResult := ARow;
      if not DisplayReport then
        begin
          tsGraphs.TabVisible := false;
          //tsSpecialResults.TabVisible := false;
          exit;
        end;
    end
  else
    begin
      with grdAdministrations do
        begin
          if (ARow = 0) then
            if SortSettings.Direction = sdDescending then
              SortSettings.Direction := sdAscending
            else
              SortSettings.Direction := sdDescending;

          SortByColumn(ACol);
          Row := 1;
          gvCurrentResult := Row;
        end;

      if not DisplayReport then
        begin
          tsGraphs.TabVisible := false;
          //tsSpecialResults.TabVisible := false;
          exit;
        end;
    end;

  //Because a new instrument result has been selected...
  lvIsFirstViewOfGraph := True;

  mnuComments.Enabled := TAResult(Result_OPS.ListOfResults[gvCurrentResult]).UserHasPermissionToView
    and (TAResult(Result_OPS.ListOfResults[gvCurrentResult]).AdministrationIENS <> '');

  grdAdministrations.SetFocus;

end;


procedure TfrmMHA_InstrumentResults.GetDLLScores;
// Get scores from a string returned by DLL
var
  TempStr,
    TempScale,
    TempScore                 : string;
  i, j, irow, icol            : integer;
begin
  icol := 1;

  for i := Result_OPS.ListOfResults.Count - 1 downto 0 do
    begin
      with TAResult(Result_OPS.ListOfResults[i]) do
        begin
          if InstrumentName = TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName then
            begin
              grdScores.Cells[icol, 0] := DateGiven;

              for j := 1 to NumberOfPieces(ListOfScores, RECORD_END) do
                begin
                  TempStr := Piece(ListOfScores, RECORD_END, j);
                  TempScale := Piece(TempStr, U, 1);
                  TempScore := Piece(TempStr, U, 3);

                  for irow := 1 to grdScores.RowCount do
                    if Trim(UpperCase(TempScale)) =
                      Trim(UpperCase(grdScores.Cells[0, irow])) then
                      grdScores.Cells[icol, irow] := TempScore;
                end;

              grdScores.ColWidths[icol] := lvDateColWidth;

              Inc(icol);
              grdScores.Refresh;
            end;

        end; // with
    end; // for i

  grdScores.ColCount := icol;
  grdScores.IntegralHeight := True;
end;

function TfrmMHA_InstrumentResults.GetScores: string;
var
  TempStr,
    TempScale,
    TempStr2                  : string;
  i, j, irow, icol            : integer;
begin
  result := OK;
  icol := 1;

  for i := Result_OPS.ListOfResults.Count - 1 downto 0 do
    begin
      with TAResult(Result_OPS.ListOfResults[i]) do
        begin
          if InstrumentName = TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName then
            begin

              // StringList within AResult:
              // ScoreName1=ScoreValue1~ScoreName2=ScoreValue2...
              if ListOfScores = '' then
                ListOfScores :=
                  Result_OPS.LoadScores(AnswersAreInLegacyFile, AdministrationIENS,
                  InstrumentName, Patient.DFN, DateSaved);

              if Pos(BAD_DATA, ListOfScores) = 0 then
                begin
                  grdScores.Cells[icol, 0] := DateGiven;
                  //Grp := 0;

                  for j := 1 to NumberOfPieces(ListOfScores, RECORD_END) do
                    begin
                      TempStr := Piece(ListOfScores, RECORD_END, j);
                      TempScale := Piece(TempStr, EQ, 1);
                      TempStr := Piece(TempStr, EQ, 2);
                      // Some have two scores: Raw and percent (or t-score), or,
                      // raw plus a label ("severe" "mild")
                      if (NumberOfPieces(TempStr, U) > 0) then
                        begin
                          TempStr2 := Piece(TempStr, U, 2);
                          if (TempStr2 = '') or not (TempStr2[1] in ['0'..'9']) then
                            TempStr := Piece(TempStr, U, 1)
                          else
                            TempStr := Piece(TempStr, U, 2);
                        end;

                      for irow := 1 to grdScores.RowCount do
                        if Trim(UpperCase(TempScale)) =
                          Trim(UpperCase(grdScores.Cells[0, irow])) then
                          grdScores.Cells[icol, irow] := TempStr;

                      grdScores.ColWidths[icol] := lvDateColWidth;
                    end;

                  Inc(icol);
                  grdScores.Refresh;
                end;
            end;
        end; // with
    end; // for i

  grdScores.ColCount := icol;
  grdScores.IntegralHeight := True;

end;

procedure TfrmMHA_InstrumentResults.grdScoresClickCell(Sender: TObject;
  ARow, ACol: Integer);
var
  i                           : Integer;
  TempStr                     : string;
  GotOne                      : boolean;
begin
  // Click changes only the multi-scale graphs
  if not TAResult(Result_OPS.ListOfResults[gvCurrentResult]).IsMultiScale then
    exit;

  grdScores.SelectionColor := clHighlight;
  grdScores.SelectionTextColor := clHighlightText;

  if (ARow = 0) then // Date selected
    begin
      if grdScores.FontStyles[aCol, 0] = [fsBold] then
        grdScores.FontStyles[aCol, 0] := []
      else
        begin
          grdScores.FontStyles[aCol, 0] := [fsBold];
          grdScores.SelectCols(aCol, 1 {col count});
        end;
      GraphScores(true, lcByDate);
    end
  else // Scale or Scale-Group selected
    begin
      grdScores.row := ARow;

      TempStr := grdScores.Cells[0, ARow];
      if TempStr <> '' then
        begin
          if TempStr[1] = ' ' then // scale name
            GraphScores(False, TempStr)
          else
            // Group scale
            begin
              GotOne := false;
              for i := 0 to grdScores.ColCount - 1 do
                if grdScores.FontStyles[i, 0] = [fsBold] then
                  GotOne := true;
              if not GotOne then
                for i := 0 to grdScores.ColCount - 1 do
                  grdScores.FontStyles[i, 0] := [fsBold];
              for i := 0 to grdScores.RowCount - 1 do
                grdScores.FontStyles[0, i] := [];
              grdScores.FontStyles[0, aRow] := [fsBold];

              GraphScores(True, lcByDate);
            end;
        end;
    end;
end;

procedure TfrmMHA_InstrumentResults.mnuMetricClick(Sender: TObject);
begin
  VisitURL(MetricURL);
end;


procedure TfrmMHA_InstrumentResults.mnuReportsClick(Sender: TObject);
begin
  PageControl1.ActivePageIndex := 0;
  PageControl1Change(Sender);
end;

procedure TfrmMHA_InstrumentResults.mnuGraphAndTableClick(
  Sender: TObject);
begin
  PageControl1.ActivePageIndex := 1;
  PageControl1Change(Sender);
end;


procedure TfrmMHA_InstrumentResults.mnuSpecialResultsClick(Sender: TObject);
begin
  PageControl1.ActivePageIndex := 2;
  PageControl1Change(Sender);
end;


procedure TfrmMHA_InstrumentResults.mnuCopyReportClick(Sender: TObject);
begin
  with memReport do
    begin
      SelectAll;
      CopyToClipboard;
    end;

  MsgDlgFrm('The report has been copied to the Windows clipboard.' + CRLF + CRLF
    + 'If you like, you may paste it into an open text document.',
    MHA_CAPTION, mtInformation, [mbOK], 0);
end;

procedure TfrmMHA_InstrumentResults.mnuCopyGraphClick(Sender: TObject);
begin
  chrtScores.Title.Visible := True;
  chrtScores.Title.Text.Add(Patient.Name + '  SSN: ' + Patient.FormattedSSN);
  chrtScores.CopyToClipboardBitmap;
  MsgDlgFrm('The graph has been copied to the Windows clipboard.' + CRLF +
    '' + CRLF +
    'If you like, you may paste it into another document (e.g., an MS Word ' +
    CRLF + 'document).', MHA_CAPTION, mtInformation, [mbOK], 0);
  chrtScores.Title.Text.Clear;
  chrtScores.Title.Text.Add(TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName);
end;

procedure TfrmMHA_InstrumentResults.mnuSaveReportClick(Sender: TObject);
begin
  with dlgSave do
    begin
      FileName := 'Test Report.rtf';
      Filter := 'Rich text file (*rtf)|*.rtf';
      if Execute then
        memReport.Lines.SaveToFile(FileName);
    end;
end;

procedure TfrmMHA_InstrumentResults.mnuSaveTableClick(Sender: TObject);
begin
  with dlgSave do
    begin
      FileName := 'Test Scores.xls';
      Filter := 'Excel file (*xls)|*.xls';
      if Execute then
        begin
          grdScores.cells[0, 0] := Patient.Name + '  SSN: ' + Patient.FormattedSSN;
          grdScores.SaveToXLS(FileName);
          grdScores.cells[0, 0] := '';
        end;
    end;
end;

procedure TfrmMHA_InstrumentResults.mnuPrintGraphClick(Sender: TObject);
begin
  frmMHA_Print := TfrmMHA_Print.Create(nil);
  frmMHA_Print.PrintChart(chrtScores, Patient.Name + '  SSN: ' + Patient.FormattedSSN
    + '  ' + TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName +
    '  Printed: ' + DateToStr(Date));
  frmMHA_Print.Free;
  chrtScores.Foot.Text.Text := '';
end;

procedure TfrmMHA_InstrumentResults.mnuSaveGraphClick(Sender: TObject);
begin
  with dlgSave do
    begin
      FileName := 'Test Scores.bmp';
      Filter := 'Bitmap files (*.bmp)|*.bmp';
      if Execute then
        begin
          chrtScores.Title.Text.Clear;
          chrtScores.Title.Visible := True;
          chrtScores.Title.Text.Add(Patient.Name + '  SSN: ' + Patient.FormattedSSN);
          chrtScores.SaveToBitmapFile(dlgSave.FileName);
          chrtScores.Title.Text.Clear;
        end;
    end;
end;

procedure TfrmMHA_InstrumentResults.mnuCopyTableClick(Sender: TObject);
begin

  grdScores.Cells[0, 0] := Patient.Name + '  SSN: ' + Patient.FormattedSSN;
  grdScores.CopyToClipBoard;
  grdScores.cells[0, 0] := '';

  MsgDlgFrm('The table has been copied to the Windows clipboard.' + CRLF +
    '' + CRLF +
    'If you like, you may paste it into an open MS Excel spreadsheet.',
    MHA_CAPTION, mtInformation, [mbOK], 0);

end;

procedure TfrmMHA_InstrumentResults.ConvertGridToStringList(var List: TStringList);
// This will list the dates on the right side of the page
// instead of the top as on the GUI.
// Only ten scales are presented across the top of the page.
const
  space                       : string = '  ';
var
  RowStart, RowEnd            : integer;
  TempStr5                    : string[5];
  TempStr                     : string;

  procedure PrintBlock;
  var
    r, c                      : integer;
  begin
    // This is the header that contains the scale names.
    // Max width of scale name is 5.
    TempStr := 'Date        ';
    for r := RowStart to RowEnd do
      begin
        if //(grdScores.FontStyles[0, r] <> [fsBold]) or
          Length(grdScores.Cells[1, r]) > 0 then
          begin
            TempStr5 := Trim(grdScores.Cells[0, r]);
            while Length(TempStr5) < 5 do
              TempStr5 := ' ' + TempStr5;
            TempStr := TempStr + TempStr5 + space;
            TempStr5 := '';
          end;
      end;
    List.Add(TempStr);
    List.Add(' ');
    TempStr := '';

    // This is the row that contains the date, then the scale scores.
    // Max width of scale score is 5.
    for c := 1 to grdScores.ColCount do
      begin
        TempStr := grdScores.Cells[c, 0] + space;
        for r := RowStart to RowEnd do
          begin
            if //(grdScores.FontStyles[0, r] <> [fsBold]) or
              Length(grdScores.Cells[1, r]) > 0 then
              begin
                TempStr5 := grdScores.Cells[c, r];
                if TempStr5 <> '' then
                  begin
                    while Length(TempStr5) < 5 do
                      TempStr5 := ' ' + TempStr5;
                    TempStr := TempStr + TempStr5 + space;
                  end;
              end;
          end;
        List.Add(' ');
        List.Add(TempStr);
        TempStr := '';
      end; //for c...
  end;

begin
  RowStart := 2;
  if grdScores.RowCount > 12 then
    RowEnd := 12
  else
    RowEnd := grdScores.RowCount;

  List.Add(' ');
  PrintBlock;

  while RowEnd < grdScores.RowCount do
    begin
      RowStart := RowEnd + 1;
      if grdScores.RowCount > RowStart + 10 then
        RowEnd := RowStart + 10
      else
        RowEnd := grdScores.RowCount;
      List.Add(' ');
      PrintBlock;
    end;
end;

procedure TfrmMHA_InstrumentResults.mnuPrintTblClick(Sender: TObject);
var
  TempStrList                 : TStringList;

begin
  if grdScores.RowCount <= 1 then
    exit;

  TempStrList := TStringList.Create;

  ConvertGridToStringList(TempStrList);

  frmMHA_Print := TfrmMHA_Print.Create(nil);
  frmMHA_Print.PrintTable(TempStrList,
    Patient.Name + '  SSN: ' + Patient.FormattedSSN +
    '  ' + TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName +
    '  Printed: ' + DateToStr(Date));
  frmMHA_Print.Free;

  TempStrList.Free;

end;

procedure TfrmMHA_InstrumentResults.mnuCommentsClick(Sender: TObject);
begin
  //Results was loaded in DisplayReport
  if (TAResult(Result_OPS.ListOfResults[gvCurrentResult]).UserHasPermissionToView)
    and (TAResult(Result_OPS.ListOfResults[gvCurrentResult]).AdministrationIENS <> '') then
    begin
      try
        frmMHA_AppendComments := TfrmMHA_AppendComments.Create(nil);
        frmMHA_AppendComments.DisplayOldComments(
          TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName + '   ' +
          TAResult(Result_OPS.ListOfResults[gvCurrentResult]).DateGiven,
          TAResult(Result_OPS.ListOfResults[gvCurrentResult]).AdministrationIENS);
        frmMHA_AppendComments.ShowModal;
      finally
        frmMHA_AppendComments.Free;
      end;

      DisplayReport;
    end
  else
    MsgDlgFrm('This report was generated with an earlier version ' +
      'of this program and can not be appended by this program. ' +
      'To append this report, open the roll-and-scroll version in Vista (DHCP).',
      MHA_CAPTION, mtInformation, [mbOK], 0);
end;

procedure TfrmMHA_InstrumentResults.mnuOptionsClick(Sender: TObject);
begin
  if gvUseScreenReader then
    begin
      try
        frmMHA_Options_508 := TfrmMHA_Options_508.Create(nil);
      finally
        frmMHA_Options_508.Free;
      end;

    end
  else
    begin
      gvShowOptionTabs := '0'; // Show tab 0 on options form, Fonts

      try
        frmMHA_Options := TfrmMHA_Options.Create(nil);
      finally
        frmMHA_Options.Free;
      end;

      if GUI_Control.NeedGUIUpdate then
        begin
          ConfigureForm;
          UpdateAllDisplays;
          DisplayReport;
        end;
    end;
end;

procedure TfrmMHA_InstrumentResults.mnuViewClick(Sender: TObject);
begin
  EnableMenus;
end;

procedure TfrmMHA_InstrumentResults.grdAdministrationsKeyDown(
  Sender: TObject; var Key: Word; Shift: TShiftState);
begin

  if (Key = vk_Return) then //and gvUseScreenReader then
    grdAdministrationsClickCell(Self, grdAdministrations.Row, 0);
  if Key = vk_Delete then
    RemoveAdmin(grdAdministrations.Cells[2, grdAdministrations.row]);
end;

procedure TfrmMHA_InstrumentResults.mnuPrintReportClick(Sender: TObject);
begin

  if PageControl1.ActivePageIndex = 2 then
    begin
      frmMHA_Print := TfrmMHA_Print.Create(nil);
      PrintSpecialResults;
      frmMHA_Print.Free;
    end
  else
    begin
      if not gvUseScreenReader then
        MsgDlgFrm('If the text in the report is excessively wrapped because of the ' +
          'narrow width of the report window, the printed report will ' +
          'be displayed in the same manner.' + #13 + #13 +
          'Expand the width of the report frame to correct this.',
          MHA_CAPTION, mtInformation, [mbOK], 0);

      frmMHA_Print := TfrmMHA_Print.Create(nil);
      frmMHA_Print.PrintRichEdit(memReport,
        Patient.Name + '  SSN: ' + Patient.FormattedSSN // xxx-xx-1234
        + '  ' + TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName +
        ' Report  Printed: ' + DateToStr(Date));
      frmMHA_Print.Free;
    end;
end;

procedure TfrmMHA_InstrumentResults.mnuOnlineSupportClick(
  Sender: TObject);
begin
  VisitURL(MHA_ONLINE_SUPPORT_URL);
end;

procedure TfrmMHA_InstrumentResults.mnuAboutClick(Sender: TObject);
begin
  frmMHA_About := TfrmMHA_About.Create(nil);
  try
    frmMHA_About.ShowModal;
  finally
    frmMHA_About.Free;
  end; //try
end;

procedure TfrmMHA_InstrumentResults.FormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Shift = [ssALT]) and (Key = vk_F4) then
    Close;

  if Key = vk_Escape then
    begin
      Close;
      Key := 0;
    end;
end;

procedure TfrmMHA_InstrumentResults.mnuShowGraphLabelsClick(
  Sender: TObject);
var
  i, t                        : integer;
begin
  mnuShowGraphLabels.Checked := not mnuShowGraphLabels.Checked;

  if mnuShowGraphLabels.Checked then
    for t := 0 to chrtScores.SeriesCount - 1 do
      begin
        if chrtScores.Series[t] is TLineSeries then
          with (chrtScores.Series[t] as TLineSeries) do
            begin
              Marks.Style := smsValue;
              Marks.Visible := true;
            end;
      end
  else
    for t := 0 to chrtScores.SeriesCount - 1 do
      begin
        if chrtScores.Series[t] is TLineSeries then
          with (chrtScores.Series[t] as TLineSeries) do
            Marks.Visible := False;
      end;

  for i := 0 to ComponentCount - 1 do
    if Components[i] is TBarSeries then
      TBarSeries(Components[i]).Marks.Visible := mnuShowGraphLabels.Checked;

end;

procedure TfrmMHA_InstrumentResults.mnuPrintBlankClick(Sender: TObject);
begin

  gvNameOfInstrument := '';

  try
    frmPrint_Instrument := TfrmPrint_Instrument.Create(nil);
  finally
    frmPrint_Instrument.Free;
  end; //try

end;



procedure TfrmMHA_InstrumentResults.imgBackupClick(Sender: TObject);
begin
  Close;
end;

function TfrmMHA_InstrumentResults.LoadInstrumentRecords: boolean;
var
  reply                       : string;
begin
  result := False;

  reply := Result_OPS.LoadCompleteResults(Patient.DFN); // uMHA_Results_OPS

  if reply <> OK then
    begin
      ShowMessage('Unable to load results.' + reply);
      Exit;
    end;

  result := True;
end;

(*
procedure TfrmMHA_InstrumentResults.InitSpecialResults;
var
  i, C1, C2, H                : Integer;
  TempStr                     : string;
begin

//  if Result_OPS.ListOfResults.Count = 0 then
//    begin
//      MsgDlgFrm('No results are available.', MHA_CAPTION,
//        mtInformation, [mbOk], 0);
//      Exit;
//    end;

  // Get the instruments the user has picked for the Special Results
  // "False" means the user does not have a list of special instruments
  if not SpecialResults_OPS.LoadUsersSpecialResultsInstruments then
    begin
      lvIsFirstViewOfSummary := False;
      tsSpecialResults.TabVisible := false;
      Exit;
    end;

  pnlLeft.Width := (sbSummary.Width div 2); // - pnlSpacer1.Width;
  lblHeader.Caption := '  Special Results';

//  sbSummary.Visible := False;
//  LoadSpecialResults; // This takes some time; progress bar used.
//  sbSummary.Visible := True;

//  if (lvListOfResults.Count = 0) then
//    Exit;

  // Keep track of height of components in each column--set height of
  // scroll box to the longest of the two.
  C1 := 200; // Column 1
  C2 := C1;

  // Sequence through the instruments the user has selected to be on
  // the Special Results page
  for i := SpecialResults_OPS.UsersListOfSpecialInstruments.Count - 1 downto 0 do
    begin

   //   if NumberofPieces(lvListOfResults[i], lcSRDelimiter) = 0 then
        //do nothing //pnlLeft.Caption := 'No results to display.'
   //   else
      if TSpecialResultInstrument(SpecialResults_OPS.UsersListOfSpecialInstruments[i]).hsShowQA then
        begin
          // Get adminID of last administration
          TempStr := piece(lvListOfResults[i], lcSRDelimiter, NumberofPieces(lvListOfResults[i], lcSRDelimiter) - 1);

          H := DrawItems(i,
            Piece(TempStr, U, 1), {AdminID}
            Piece(TempStr, U, 2), {Date}
            TSpecialResultInstrument(SpecialResults_OPS.UsersListOfSpecialInstruments[i]));
          if Odd(i) then
            C1 := C1 + H
          else
            C2 := C2 + H;
        end;

      H := DrawGuide(i, TSpecialResultInstrument(SpecialResults_OPS.UsersListOfSpecialInstruments[i]));
      if Odd(i) then
        C1 := C1 + H
      else
        C2 := C2 + H;

      H := DrawHSGraph(i, TSpecialResultInstrument(SpecialResults_OPS.UsersListOfSpecialInstruments[i]));
      if Odd(i) then
        C1 := C1 + H
      else
        C2 := C2 + H;
    end; // for i

  H := DrawPtInfo;
  C1 := C1 + H;

  if C1 > C2 then
    sbSummary.vertscrollbar.Range := C1
  else
    sbSummary.vertscrollbar.Range := C2;

  sbSummary.VertScrollBar.Position := 0;

  lvIsFirstViewOfSummary := False;

end;*)


function TfrmMHA_InstrumentResults.BuildSpecialResults: boolean;
var
  i, C1, C2, H                : Integer;
  TempStr                     : string;
begin

  Result := False;

  pnlLeft.Width := (sbSummary.Width div 2); // - pnlSpacer1.Width;
  lblHeader.Caption := '  Special Results';

  // Get the instruments the user has picked for the Special Results
  // "False" means the user does not have a list of special instruments
  if not SpecialResults_OPS.LoadUsersSpecialResultsInstruments then
    begin
      lvIsFirstViewOfSummary := False;
      tsSpecialResults.TabVisible := false;
      Exit;
    end;

  sbSummary.Visible := False;
  LoadSpecialResults; // This takes some time; progress bar used.
  sbSummary.Visible := True;

  if (lvListOfResults.Count = 0) then
    begin
      lvIsFirstViewOfSummary := False;
      tsSpecialResults.TabVisible := false;
      Exit;
    end;

  // Keep track of height of components in each column--set height of
  // scroll box to the longest of the two.
  C1 := 200; // Column 1
  C2 := C1;

  // Sequence through the instruments the user has selected to be on
  // the Special Results page
  for i := SpecialResults_OPS.UsersListOfSpecialInstruments.Count - 1 downto 0 do
    begin

   //   if NumberofPieces(lvListOfResults[i], lcSRDelimiter) = 0 then
        //do nothing //pnlLeft.Caption := 'No results to display.'
   //   else
      if TSpecialResultInstrument(SpecialResults_OPS.UsersListOfSpecialInstruments[i]).hsShowQA then
        begin
          // Get adminID of last administration
          TempStr := piece(lvListOfResults[i], lcSRDelimiter, NumberofPieces(lvListOfResults[i], lcSRDelimiter) - 1);

          H := DrawItems(i,
            Piece(TempStr, U, 1), {AdminID}
            Piece(TempStr, U, 2), {Date}
            TSpecialResultInstrument(SpecialResults_OPS.UsersListOfSpecialInstruments[i]));

          if Odd(i) then
            C1 := C1 + H
          else
            C2 := C2 + H;
        end;

      H := DrawGuide(i, TSpecialResultInstrument(SpecialResults_OPS.UsersListOfSpecialInstruments[i]));
      if Odd(i) then
        C1 := C1 + H
      else
        C2 := C2 + H;

      H := DrawHSGraph(i, TSpecialResultInstrument(SpecialResults_OPS.UsersListOfSpecialInstruments[i]));
      if Odd(i) then
        C1 := C1 + H
      else
        C2 := C2 + H;
    end; // for i

  H := DrawPtInfo;
  C1 := C1 + H;

  if C1 > C2 then
    sbSummary.vertscrollbar.Range := C1
  else
    sbSummary.vertscrollbar.Range := C2;

  sbSummary.VertScrollBar.Position := 0;

  lvIsFirstViewOfSummary := False;
  Result := True;
end;

procedure TfrmMHA_InstrumentResults.PrintSpecialResults;
var
  i                           : Integer;
begin
  // Print the header.
  // Sets printer's fonts, etc.
  frmMHA_Print.PrintSpecResultHeader(
    Patient.Name + '     ' + Patient.FormattedSSN +
    '    Date Printed: ' + DateToStr(Date));

  for i := ComponentCount - 1 downto 0 do
    begin
      if Components[i] is TGroupBox then
        with TGroupBox(Components[i]) do
          begin

            if POS(lcGroupBox, Name) > 0 then
              begin
                // Header for Questions & Answers
                frmMHA_Print.PrintSpecResultsGBLine(Caption);
              end;
          end;

      // End of the series--no need to go further.
      if Components[i] is TPanel then
        with TPanel(Components[i]) do
          if Name = 'pnlSpacer2' then
            break;

      if Components[i] is TLabel then
        with TLabel(Components[i]) do
          begin
            // Chart's interpretation
            if POS(lcLabelGuide, Name) > 0 then
              frmMHA_Print.PrintSpecResultsLine(Caption);

            // Questions & Answers
            if POS(lcLabel, Name) > 0 then
              begin
                if Caption = lcView then // Ignore line of instructions
                else
                  frmMHA_Print.PrintSpecResultsQALine(Caption);
              end;
          end;

      if Components[i] is TChart then
        begin
          if POS(lcChart, TChart(Components[i]).Name) > 0 then
              // Chart
            frmMHA_Print.PrintSpecResultsChart(TChart(Components[i]));
        end;
    end; // for i

  // Close down the printer
  frmMHA_Print.PrintSpecResultsEnd;
end;


procedure TfrmMHA_InstrumentResults.ChangeAnswers(aTitle, aDate: string;
  WhichOne, WhichResult: integer);
var
  i, p                        : Integer;
  TempAdminID,
    TempStr,
    TempInt                   : string;
begin
  TempStr := Piece(lvListOfResults[WhichResult], lcSRDelimiter, WhichOne);
  TempAdminID := Piece(TempStr, U, 1);

  MHA_Report_OPS.ListOfAnswersForReport.Clear;
  MHA_Report_OPS.ListOfQuestionsForReport.Clear;

  if LoadQuestionsForReport(aTitle, DataModule1.RPCBroker1) <> OK then
    begin
      ShowMessage('Unable to load question data from VistA.');
      Exit;
    end;

  if LoadQuestionChoicesForReport(aTitle, DataModule1.RPCBroker1) <> OK then
    begin
      ShowMessage('Unable to load choices on question data from VistA.');
      Exit;
    end;

  if LoadAnswersForReport(TempAdminID, Patient.DFN, DataModule1.RPCBroker1) <> OK then
    begin
      ShowMessage('Unable to load answer data from VistA.');
      Exit;
    end;

  for i := 0 to ComponentCount - 1 do
    begin
      if Components[i] is TGroupBox then
        with TGroupBox(Components[i]) do
          begin
            if (Name = lcGroupBox + aTitle) then
              begin
                p := Pos('for ', Caption);
                if p > 0 then
                  Caption := Copy(Caption, 1, p + 3) + aDate;
              end;
          end;

      if Components[i] is TLabel then
        with TLabel(Components[i]) do
          begin
            p := Pos(lcLabel + aTitle, Name);
            if p > 0 then
              begin
                TempInt := Copy(Name, p, Length(Name) - p - 1);
                TempStr := SEPARATOR;
                p := Pos(TempStr, Caption);
                if p > 0 then
                  Caption := Copy(Caption, 1, p) +
                    MHA_Report_OPS.GetAnswer(IntToStr(Tag)); // QuestionID
              end;
          end;
    end;
end;


function TfrmMHA_InstrumentResults.DrawItems(WhichOne: Integer;
  aAdminID, aDate: string; aSpecialResult: TSpecialResultInstrument): integer;
var
  QuestionTop,
    i                         : Integer;
  TempQuest,
    TempTitle                 : string;

  function BuildItem(LabelIn: TLabel; WhichOne: Integer; aQID, aName,
    CaptionIn: string): integer;
  begin
    with LabelIn do
      begin
        Parent := lvGroupBox;
        Name := lcLabel + aName + IntToStr(WhichOne);
        AutoSize := True;
        Align := alTop;
        Font.Assign(gvFont);
        Alignment := taLeftJustify;
        WordWrap := True;
        Caption := CaptionIn;
        Tag := StrtoIntDef(aQID, 0);
        Layout := tlTop;

        // height is set properly when wrapped.
        Result := Height;
      end;
  end;

begin
  result := 0;

  if aAdminID = '' then
    exit;

  MHA_Report_OPS.ListOfAnswersForReport.Clear;
  MHA_Report_OPS.ListOfQuestionsForReport.Clear;

  if LoadQuestionsForReport(aSpecialResult.hsTitle, DataModule1.RPCBroker1) <> OK then
    begin
      ShowMessage('Unable to load question data from VistA.');
      Exit;
    end;

  if LoadQuestionChoicesForReport(aSpecialResult.hsTitle, DataModule1.RPCBroker1) <> OK then
    begin
      ShowMessage('Unable to load choices on question data from VistA.');
      Exit;
    end;

  if LoadAnswersForReport(aAdminID, Patient.DFN, DataModule1.RPCBroker1) <> OK then
    begin
      ShowMessage('Unable to load answer data from VistA.');
      Exit;
    end;

  lvGroupBox := TGroupBox.Create(Self);

  // Remove spaces from title of instrument
  TempTitle := RemoveSpaces(aSpecialResult.hsTitle);

  with lvGroupBox do
    begin
      Name := lcGroupBox + TempTitle;

      if Odd(WhichOne + 1) then
        begin
          Parent := pnlLeft;
          lvGroupBox.Width := pnlLeft.Width;
        end
      else
        begin
          Parent := pnlRight;
          lvGroupBox.Width := pnlRight.Width;
        end;


      Align := alTop;
      Caption := '  ' + aSpecialResult.hsTitle + ' responses for ' + aDate + '  ';
      Font.Assign(gvFont);
      Font.Style := [fsBold];

      QuestionTop := 0; //GUI_Control.GetStandardHeight(gvFont);

      for i := MHA_Report_OPS.ListOfQuestionsForReport.Count - 1 downto 0 do
        begin
          //TempAns := Piece(lvListOfAnswers[WhichOne], U, i + 2);
          //if aWriteFullText then
          TempQuest := TQuestion(MHA_Report_OPS.ListOfQuestionsForReport[i]).qCaption +
            CRLF + lcspace + SEPARATOR +
            MHA_Report_OPS.GetAnswer(
            TQuestion(MHA_Report_OPS.ListOfQuestionsForReport[i]).QuestionID);

          QuestionTop := QuestionTop +
            BuildItem(TLabel.Create(self), i,
            TQuestion(MHA_Report_OPS.ListOfQuestionsForReport[i]).QuestionID,
            TempTitle, TempQuest);
        end;

      Inc(lvDigit);
      QuestionTop := QuestionTop +
        BuildItem(TLabel.Create(self), 0, '', Inttostr(lvDigit),
        lcView);

      Height := QuestionTop + GUI_Control.GetStandardHeight(gvFont);
      result := Height;
    end; // with
end;

function TfrmMHA_InstrumentResults.DrawGuide(WhichOne: Integer;
  aSpecialResult: TSpecialResultInstrument): Integer;
var
  TempTitle                   : string;

begin
  // Remove any spaces from title
  TempTitle := RemoveSpaces(aSpecialResult.hsTitle);

  lvPanel := TPanel.Create(Self);
  with lvPanel do
    begin
      Name := lcPanel + TempTitle;

      if Odd(WhichOne + 1) then
        begin
          Parent := pnlLeft;
          lvPanel.Width := pnlLeft.Width;
        end
      else
        begin
          Parent := pnlRight;
          lvPanel.Width := pnlRight.Width;
        end;

      Height := GUI_Control.GetWrapHeight(aSpecialResult.hsGuide, Width, gvFont);
      Color := clBtnFace;
      Align := alTop;
      BevelInner := bvNone;
      BevelOuter := bvNone;
      bevelWidth := 1;
      BorderStyle := bsNone;
      TabStop := False;
      Caption := '';
      result := Height;
    end; // with

  lvLabel := TLabel.Create(Self);
  with lvLabel do
    begin
      Name := lcLabelGuide + TempTitle;
      Parent := lvPanel;
      Color := clBtnFace;
      Align := alClient;
      Alignment := taLeftJustify;
      Font.Assign(gvFont);
      Layout := tlCenter;
      WordWrap := True;
      Caption := aSpecialResult.hsGuide;
    end; // with
end;


function TfrmMHA_InstrumentResults.DrawHSGraph(WhichOne: Integer;
  aSpecialResult: TSpecialResultInstrument): integer;
var
  i, j, k, x                  : Integer;
  TempTitle,
    TempStr2,
    TempStr1,
    TempStr                   : string;
  TempColor                   : TColor;
  //DateSeries : TChartSeries;
  BarSeries                   : TBarSeries;

  function DrawGAF: integer;
  var
    ii, kk                    : Integer;
  begin
    GAF_OPS.GetPreviousGAFRatings(Patient.DFN);

    lvChart.LeftAxis.Automatic := False;
    lvChart.LeftAxis.AutomaticMaximum := False;
    lvChart.LeftAxis.AutomaticMinimum := False;
    lvChart.LeftAxis.Minimum := aSpecialResult.hsMin;
    lvChart.LeftAxis.Maximum := aSpecialResult.hsMax;

    BarSeries := TBarSeries.Create(self);
    BarSeries.ParentChart := lvChart;
    BarSeries.BarStyle := bsRectangle;
    BarSeries.BarWidthPercent := 70;
    BarSeries.MultiBar := mbSide;
    BarSeries.ValueFormat := '#,##0.###';
    BarSeries.PercentFormat := '##0.## %';
    BarSeries.HorizAxis := aBottomAxis;
    BarSeries.VertAxis := aLeftAxis;
    if mnuShowGraphLabels.Checked then
      BarSeries.Marks.Visible := True
    else
      BarSeries.Marks.Visible := False;
    BarSeries.Marks.Style := smsValue;

    TempColor := clWhite;

    for ii := 0 to GAF_OPS.ListOfGAFs.Count - 1 do
      begin
        for kk := 0 to aSpecialResult.ListOfColorBands.Count - 1 do
          begin
            if (TGAF(GAF_OPS.ListOfGAFs[ii]).Rating <= StrToInt(Piece(aSpecialResult.ListOfColorBands[kk], '-', 1))) and
              (TGAF(GAF_OPS.ListOfGAFs[ii]).Rating >= StrToInt(Piece(aSpecialResult.ListOfColorBands[kk], '-', 2))) then
              TempColor := StringToColor(Piece(aSpecialResult.ListOfColorBands[kk], '-', 3));
//            if (TGAF(GAF_OPS.ListOfGAFs[ii]).Rating <= ThsColorBand(aSpecialResult.ListOfColorBands[kk]).cbMax) and
//              (TGAF(GAF_OPS.ListOfGAFs[ii]).Rating > ThsColorBand(aSpecialResult.ListOfColorBands[kk]).cbMin) then
//              TempColor := StringToColor(ThsColorBand(aSpecialResult.ListOfColorBands[kk]).cbColor);
          end; // for kk

        BarSeries.Add(TGAF(GAF_OPS.ListOfGAFs[ii]).Rating,
          TGAF(GAF_OPS.ListOfGAFs[ii]).DateString,
          TempColor);
      end; // for ii
    result := lvChart.Height;
  end;

begin
  result := 200;
  TempColor := clYellow;

  // Remove any spaces from title
  TempTitle := RemoveSpaces(aSpecialResult.hsTitle);

  lvChart := TChart.Create(Self);
  lvChart.Name := lcChart + TempTitle;
  lvChart.Tag := WhichOne; // used later for changing answers

  if Odd(WhichOne + 1) then
    begin
      lvChart.Parent := pnlLeft;
      lvChart.Width := pnlLeft.Width;
    end
  else
    begin
      lvChart.Parent := pnlRight;
      lvChart.Width := pnlRight.Width;
    end;

  lvChart.Height := aSpecialResult.hsHeight;
  lvChart.BackColor := clWhite;
  lvChart.Color := clWhite;
  lvChart.BevelInner := bvNone;
  lvChart.BevelOuter := bvNone;
  lvChart.Align := alTop;
  lvChart.AxisVisible := True;

  lvChart.BottomAxis.Automatic := false;
  lvChart.BottomAxis.AutomaticMaximum := True;
  lvChart.BottomAxis.AutomaticMinimum := True;
  lvChart.BottomAxis.AxisValuesFormat := '#,##0.###';
  lvChart.BottomAxis.DateTimeFormat := 'mm/dd/yyyy';
  lvChart.BottomAxis.ExactDateTime := True;
  lvChart.BottomAxis.Inverted := true; // Old..New. Matches graph results
  lvChart.BottomAxis.LabelsOnAxis := True;
  lvChart.BottomAxis.LabelsAngle := 305;
  lvChart.BottomAxis.LabelsSeparation := 0;
  lvChart.BottomAxis.LabelsFont.Assign(gvFont);
  lvChart.BottomAxis.LabelsFont.size := 8;
  lvChart.BottomAxis.LabelsMultiLine := True;

  lvChart.Title.Text.Clear;
  lvChart.Title.text.add(aSpecialResult.hsTitle);
  lvChart.Title.Font.Assign(gvFont);
  lvChart.Title.Font.Style := [fsBold];

  lvChart.LeftAxis.LabelsFont.Assign(gvFont);

  lvChart.View3D := False;
  lvChart.View3DWalls := False;
  lvChart.Legend.Visible := False;

  if aSpecialResult.hsShowQA then
    lvChart.OnClickSeries := UpdateClickSeries;

  if aSpecialResult.hsTitle = 'GAF' then
    begin
      Result := DrawGAF;
      Exit;
    end;

  if lvListOfResults[WhichOne] = '' then
    begin
      lvChart.BottomAxis.Visible := False;
      Exit;
    end;

  if aSpecialResult.hsSeriesCount = 0 then
    begin
      lvChart.LeftAxis.Automatic := False;
      lvChart.LeftAxis.AutomaticMaximum := true;
      lvChart.LeftAxis.AutomaticMinimum := true;

      BarSeries := TBarSeries.Create(self);
      BarSeries.ParentChart := lvChart;
      BarSeries.BarStyle := bsRectangle;
      BarSeries.BarWidthPercent := 70;
      BarSeries.MultiBar := mbSide;
      BarSeries.ValueFormat := '#,##0.###';
      BarSeries.PercentFormat := '##0.## %';
      BarSeries.HorizAxis := aBottomAxis;
      BarSeries.VertAxis := aLeftAxis;
      if mnuShowGraphLabels.Checked then
        BarSeries.Marks.Visible := True
      else
        BarSeries.Marks.Visible := False;
      BarSeries.Marks.Style := smsValue;

      for i := 1 to NumberofPieces(lvListOfResults[WhichOne], lcSRDelimiter) - 1 do
        begin
          TempStr := Piece(lvListOfResults[WhichOne], lcSRDelimiter, i);

          if TempStr = '' then
            x := 0
          else
            x := StrToIntDef(Piece(TempStr, U, 3), 0);

          // patch 105, changed x > logic when comparing piece 2 to x >= llh
          for k := 0 to aSpecialResult.ListOfColorBands.Count - 1 do
            if (x <= StrToInt(Piece(aSpecialResult.ListOfColorBands[k], '-', 1))) and
              (x >= StrToInt(Piece(aSpecialResult.ListOfColorBands[k], '-', 2))) then
              TempColor := StringToColor(Piece(aSpecialResult.ListOfColorBands[k], '-', 3));

          BarSeries.Add(StrToIntDef(Piece(TempStr, U, 3), 0), Piece(TempStr, U, 2), TempColor);
        end; // for i
    end // if
  else
    // Multiple scales
    begin
      lvChart.Height := aSpecialResult.hsHeight;
      lvChart.Legend.Visible := True;
      lvChart.Legend.Alignment := laTop;

      lvChart.LeftAxis.Automatic := True;
      lvChart.LeftAxis.AutomaticMaximum := True;
      lvChart.LeftAxis.AutomaticMinimum := True;

      lvChart.BottomAxis.AutomaticMaximum := True;
      lvChart.BottomAxis.AutomaticMinimum := True;
      lvChart.BottomAxis.ExactDateTime := False;
      lvChart.BottomAxis.inverted := true;
      lvChart.BottomAxis.Labels := True;
      lvChart.BottomAxis.LabelsOnAxis := True;
      lvChart.BottomAxis.LabelsSeparation := 0;
      lvChart.BottomAxis.LabelStyle := talText;
      lvChart.BottomAxis.LabelsMultiLine := true;

      for i := 0 to aSpecialResult.hsSeriesCount - 1 do
        begin
          BarSeries := TBarSeries.Create(self);
          BarSeries.ParentChart := lvChart;
          BarSeries.BarStyle := bsRectangle;
          BarSeries.BarWidthPercent := 70;
          BarSeries.MultiBar := mbSide;
          BarSeries.ValueFormat := '#,##0.###';
          BarSeries.PercentFormat := '##0.## %';
          BarSeries.HorizAxis := aBottomAxis;
          BarSeries.VertAxis := aLeftAxis;
          if mnuShowGraphLabels.Checked then
            BarSeries.Marks.Visible := True
          else
            BarSeries.Marks.Visible := False;
          BarSeries.Marks.Style := smsValue;
        end;

//      for i := 0 to 5 do
//        begin
//          lvChart.Series[i].Active := False;
//          lvChart.Series[i].ShowInLegend := False;
//        end;

      x := 0;

      // Start at most recent, go backwards. 6 is max.
      for i := NumberofPieces(lvListOfResults[WhichOne], lcSRDelimiter) - 1 downto 1 do
        begin
          if x > 5 then
            Exit;

          TempStr := Piece(lvListOfResults[WhichOne], lcSRDelimiter, i);

//          DateSeries := TChartSeries.Create(lvChart);
//          DateSeries.Active := true;
//          DateSeries.ShowInLegend := True;
//          DateSeries.Title := Piece(TempStr, U, 2);
//          lvChart.AddSeries(DateSeries);

          lvChart.Series[x].Active := True;
          lvChart.Series[x].ShowInLegend := True;
          lvChart.Series[x].Title := Piece(TempStr, U, 2); // date
          lvChart.Series[x].SeriesColor := lvColorList[x];

          for j := 2 to NumberofPieces(TempStr, RECORD_END) do
            begin

              TempStr2 := '';
              TempStr1 := Piece(TempStr, RECORD_END, j);

              if TempStr1 <> '' then
                begin
                 // For non-dll formats:
                 // 957^09/01/2011^~Physical Functioning=15^25.00~Role-Physical=6^50.00~...
                  if POS(EQ, TempStr1) > 0 then
                    begin
                      // The first value is raw score, then scaled score (if it is used)
                      TempStr2 := Piece(TempStr1, EQ, 2);

                      if NumberOfPieces(TempStr2, U) > 0 then
                        TempStr2 := Piece(TempStr2, U, 2);

                      if TempStr2 = '' then
                        TempStr2 := Piece(Piece(TempStr1, EQ, 2), U, 1);

                      lvChart.Series[x].Add(StrToFloat(TempStr2), // Value
                        Piece(TempStr1, EQ, 1), // Label
                        lvColorList[x]);
                    end
                  else
                 // For dll formats:
                 // 972^09/15/2011^~   Depression and Functioning^^2.82~   Interpersonal Problems^^1.00~...
                    begin
                      TempStr2 := Piece(TempStr1, U, 3); // T-score, if it exists

                      if TempStr2 = '' then
                        TempStr2 := Piece(TempStr1, U, 2); // raw score

                      lvChart.Series[x].Add(StrToFloat(TempStr2), // Value
                        Trim(Piece(TempStr1, U, 1)), // Label
                        lvColorList[x]);
                    end;
                end; // if blank
            end; // for j
          Inc(x);
        end; // for i

    end; // Multiple series

  result := lvChart.Height;
end;


procedure TfrmMHA_InstrumentResults.LoadSpecialResults;
var
  i, j, ii                    : Integer;
  AnswerString                : string;
begin
  lvListOfResults.Clear;
  // This is a list of all the instruments with its results.

  for i := 0 to SpecialResults_OPS.UsersListOfSpecialInstruments.Count - 1 do
    lvListOfResults.add('');

  frmMHA_Progress := TfrmMHA_Progress.Create(nil);
  try
    frmMHA_Progress.SetupProgressBar(' Searching for special results . . .',
      Result_OPS.ListOfResults.Count - 1);

    for i := 0 to Result_OPS.ListOfResults.Count - 1 do
      begin
        frmMHA_Progress.IncreaseProgressBar;

        for j := 0 to SpecialResults_OPS.UsersListOfSpecialInstruments.Count - 1 do
          begin
            // GAF scores are already loaded; this happens in Main form
            // This fetches the raw scores. If the DLL is used to score the scales,
            // then that work is done later.
            if TAResult(Result_OPS.ListOfResults[i]).InstrumentName =
              TSpecialResultInstrument(SpecialResults_OPS.UsersListOfSpecialInstruments[j]).hsTitle then
              begin
                with TAResult(Result_OPS.ListOfResults[i]) do
                  begin
                    // This is a quick check to see if the instrument uses the dll
                    // Returns lvDLLResults = 'YES' or 'NO'
                    LoadScoresFromDLL(InstrumentName, InstrumentName);

                    // ---- Instruments scored in DLL ----
                    if lvDLLResults = YES then
                      begin
                        AnswerString := '';
                        MHA_Report_OPS.ListOfAnswersForReport.Clear;

                        if LoadAnswersForReport(AdministrationIENS,
                          Patient.DFN, DataModule1.RPCBroker1) <> OK then
                          begin
                            ShowMessage('Unable to load answer data from VistA.');
                            Exit;
                          end;

                        for ii := 0 to MHA_Report_OPS.ListOfAnswersForReport.Count - 1 do
                          AnswerString := AnswerString +
                            TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).QuestionID + EQ +
                            GetItemIndex(TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).QuestionID,
                            TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue) + U +
                            TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue + U +
                            TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerID +
                            RECORD_END;

                        LoadScoresFromDLL(InstrumentName, AnswerString);

                        ListOfScores := lvDLLResults;
                      end
                    else
                      ListOfScores := Result_OPS.LoadScores(
                        AnswersAreInLegacyFile, AdministrationIENS,
                        InstrumentName, Patient.DFN, DateGiven);

                    if TSpecialResultInstrument(SpecialResults_OPS.UsersListOfSpecialInstruments[j]).hsSeriesCount = 0 then
                      lvListOfResults[j] := lvListOfResults[j] +
                        AdministrationIENS + U +
                        DateGiven + U +
                        Piece(ListOfScores, EQ, 2) + lcSRDelimiter
                    else
                      lvListOfResults[j] := lvListOfResults[j] +
                        AdministrationIENS + U +
                        DateGiven + U + RECORD_END + ListOfScores + lcSRDelimiter;
                  end;
              end;
          end; // for j

      end; // for i
  finally
    frmMHA_Progress.Free;
  end; // try
end;


function TfrmMHA_InstrumentResults.DrawPtInfo: integer;
var
  LabelTop                    : Integer;

  function BuildLabel(LabelIn: TLabel; WhichOne: Integer; aName,
    CaptionIn: string): integer;
  begin
    with LabelIn do
      begin
        Parent := lvPanel;
        Name := 'lbl' + aName + IntToStr(WhichOne);
        AutoSize := False;
        Top := LabelTop;
        Left := 10;
        LabelIn.Width := lvPanel.Width - (2 * Left);
        Font.Assign(gvFont);
        Font.Style := [fsBold];
        Alignment := taLeftJustify;
        WordWrap := True;
        Caption := CaptionIn;

        // Check for wrapping of the caption
        Height := GUI_Control.GetWrapHeight(Caption, Width, gvFont);
        if Height > GUI_Control.GetStandardHeight(gvFont) then
          Layout := tlTop
        else
          Layout := tlCenter;

        Result := Height;
      end;
  end;

begin
  lvPanel := TPanel.Create(Self);
  with lvPanel do
    begin
      Name := 'pnlPtInfo';
      Parent := pnlLeft;
      lvPanel.Width := pnlLeft.Width;
      Align := alTop;
      Caption := '';
      BevelInner := bvNone;
      BevelOuter := bvNone;
      Font.Assign(gvFont);
      Font.Style := [];

      LabelTop := GUI_Control.GetStandardHeight(gvFont);
      LabelTop := LabelTop +
        BuildLabel(TLabel.Create(self), 1, Name,
        '    Name: ' + Piece(Patient.Name, ',', 1) + ', ' + Piece(Patient.Name, ',', 2));

      LabelTop := LabelTop +
        BuildLabel(TLabel.Create(self), 2, Name,
        '    DOB: ' + Patient.DOB + '  (' +
        IntToStr(YearsBetween(Now, StrToDate(DateStrToMMDDYYYYFormat(Patient.DOB, '/')))) + ')');

      if Patient.Sex = 'F' then
        LabelTop := LabelTop +
          BuildLabel(TLabel.Create(self), 3, Name, '    Gender: Female')
      else
        LabelTop := LabelTop +
          BuildLabel(TLabel.Create(self), 3, Name, '    Gender: Male');

      Height := LabelTop + GUI_Control.GetStandardHeight(gvFont) div 2;
      result := Height;
    end; // with
end;


procedure TfrmMHA_InstrumentResults.UpdateClickSeries(
  Sender: TCustomChart; Series: TChartSeries; ValueIndex: Integer;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ChangeAnswers(Copy(Sender.Name, 4, Length(Sender.Name) - 3),
    Series.XLabel[ValueIndex], ValueIndex + 1, Sender.Tag);
end;


 (*
procedure TfrmMHA_InstrumentResults.sbSummaryResize(Sender: TObject);
begin
  pnlLeft.Width := (sbSummary.Width div 2) - pnlSpacer1.Width -
    pnlSpacer2.Width div 2;
end; *)


procedure TfrmMHA_InstrumentResults.mnuCopyClick(Sender: TObject);
begin
  EnableMenus;
end;

procedure TfrmMHA_InstrumentResults.mnuFileClick(Sender: TObject);
begin
  EnableMenus;
end;

procedure TfrmMHA_InstrumentResults.grdAdministrationsMouseDown(
  Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
//  if button = mbRight then
//    RemoveAdmin(grdAdministrations.Cells[2, grdAdministrations.row]);
end;

procedure TfrmMHA_InstrumentResults.RemoveAdmin(aAdminID: string);
var
  reply                       : TModalResult;
  replyStr                    : string;
begin
 // Are you sure??
  reply := MsgDlgFrm(
    '1) This operation can not be reversed later. ' + #13 + #13 +
    '2) Only the data are removed ' +
    'from VistA; any progress note, consults, etc. based on ' +
    'these data are not deleted or changed by this action.' + #13 + #13 +
    'Are you sure you want to permanently delete ' +
    'the results of the ' + grdAdministrations.Cells[1, grdAdministrations.row] +
    ' administered on ' + grdAdministrations.Cells[0, grdAdministrations.row] +
    '? ', '', mtWarning, [mbNo, mbYes], 0);

  if reply = mrNo then
    exit;

  ReplyStr := Administration_OPS.DeleteAdmin(aAdminID);

   // Does the user have the authority to delete data?
  if (POS('no priviledge', ReplyStr) > 0) or
    (POS('no privilege', ReplyStr) > 0) then
    begin
      MsgDlgFrm('Sorry, only users with the MHS Manager Menu can perform this task, ' +
        'usually the Clinical Application Coordinators (CACs) are authorized.' + #13 + #13 +
        'It is possible to remove data from VistA when ' +
        'an instrument was administered in error. Because there are serious ' +
        'issues concerning changes to a medical record, after the fact, ' +
        'it must be done carefully.', MHA_CAPTION, mtInformation, [mbOK], 0);
      exit;
    end;

  if replyStr = OK then
    begin
      UpdateAllDisplays;
      MsgDlgFrm('The data were deleted. ' + #13 + #13 +
        'Remember that progress notes, consults, etc. are not deleted or ' +
        'changed by this process.', MHA_CAPTION, mtInformation, [mbOK], 0);
    end
  else
    MsgDlgFrm('The data were not deleted. An error has occured: ' + #13 + #13 +
      replyStr, MHA_CAPTION, mtError, [mbOK], 0);
end;

procedure TfrmMHA_InstrumentResults.mnuDeleteClick(Sender: TObject);
begin
  RemoveAdmin(grdAdministrations.Cells[2, grdAdministrations.row]);
end;

procedure TfrmMHA_InstrumentResults.mnuSpecialReportWizardClick(
  Sender: TObject);
var
  TempStr                     : string;
begin
  tempstr := gvSpecialResultsList;

  try
    frmMHA_SpecialResultsWizard := TfrmMHA_SpecialResultsWizard.Create(nil);
  finally
    frmMHA_SpecialResultsWizard.Free;
  end; //try

 // Rebuild Special Result tab if changes made
  if TempStr <> gvSpecialResultsList then
    begin
      gvShowOptionTabs := 'SR';
      Close;
    end;

(*
  // Rebuild Special Result tab if changes made
  if (PageControl1.ActivePageIndex = 2) and
    (TempStr <> gvSpecialResultsList) then
    begin
      // Remove the old stuff.
      i := ComponentCount;
      while i > 0 do
        begin
          Dec(i);
          if Components[i] is TChart then
            begin
              TChart(Components[i]).Free;
              // There maybe components that have this as a parent.
              // Using Dec(i) will cause a list error.
              i := ComponentCount - 1;
            end;

          if Components[i] is TBarSeries then
            begin
              TBarSeries(Components[i]).Free;
              i := ComponentCount - 1;
            end;

          if Components[i] is TGroupBox then
            begin
              TGroupBox(Components[i]).Free;
              i := ComponentCount - 1;
            end;

          if Components[i] is TPanel then
            begin
              if ('pnlPtInfo' = TPanel(Components[i]).Name) or
                (POS(lcPanel, TPanel(Components[i]).Name) > 0) then
                begin
                  TPanel(Components[i]).Free;
                  i := ComponentCount - 1;
                end;
            end;
        end; // for i

      BuildSpecialResults;
    end;
*)
end;


procedure TfrmMHA_InstrumentResults.ReadScoresFromDLLInstrument(aInstrumentName: string);
var
  i, ii                       : integer;
  AnswerString                : string;
begin

  for i := 0 to Result_OPS.ListOfResults.Count - 1 do
    begin
      if aInstrumentName = TAResult(Result_OPS.ListOfResults[i]).InstrumentName then
        begin
          AnswerString := '';
          lvDLLResults := '';
          MHA_Report_OPS.ListOfAnswersForReport.Clear;

          if LoadAnswersForReport(
            TAResult(Result_OPS.ListOfResults[i]).AdministrationIENS,
            Patient.DFN,
            DataModule1.RPCBroker1) <> OK then
            begin
              ShowMessage('Unable to load answer data from VistA.');
              Exit;
            end;

          // First step: Get answers for each administration.
          for ii := 0 to MHA_Report_OPS.ListOfAnswersForReport.Count - 1 do
            AnswerString := AnswerString +
              TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).QuestionID + EQ +
              GetItemIndex(TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).QuestionID,
              TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue) + U +
              TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue + U +
              TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerID +
              RECORD_END;

          LoadScoresFromDLL(aInstrumentName, AnswerString);
          // Updates lvDLLResults

          TAResult(Result_OPS.ListOfResults[i]).ListOfScores := lvDLLResults;
        end; // This instrument
    end; // for i
end;

procedure TfrmMHA_InstrumentResults.LoadScoresFromDLL(InstrumentName, AnswerString: string);
var
  ResultString                : string;
  dllHandle                   : THandle;

begin
  lvDLLResults := NO;

  // patch 105 added gvAuxFile which = proper C:\Program Files dir for the YS_MHA_AUX file llh
  dllHandle := LoadLibrary(PChar(gvAuxFile));

  if dllHandle = 0 then
  begin
    // patch 105 added gvAuxFile, removed C:\Program Files llh
    MsgDlgFrm('Could not find DLL used for displaying instruments.' +
      'The file YS_MHA_AUX.DLL is usually located in ' + gvAuxFile , '',
      mtWarning, [mbOk], 0)
  end
  else
    begin
      try

        @ScoreAnswersDLL := GetProcAddress(dllHandle, 'ScoreAnswers');

        if @ScoreAnswersDLL = nil then
          // function not found
          Exit;

        if Assigned(ScoreAnswersDLL) then
          ScoreAnswersDLL(
            InstrumentName,
            '', // PatientName,
            '', // PatientDOB,
            '', // PatientSex,
            AnswerString,
            ResultString);

        lvDLLResults := ResultString;
        // Format is:
        // ScaleName1^T-Score1^RawScore1~ScaleName2^T-Score2^RawScore2~
        //'N1: Anxiety^' + IntToStr(GetTScore('N1', N1)) + '^' + IntToStr(N1) + RECORD_END +
      finally
        FreeLibrary(dllHandle);
      end; {try..finally}
    end;
end;

function TfrmMHA_InstrumentResults.NeedsSpecialLegacy508Report(aInstrumentName: string): boolean;
// The reports from these legacy instruments are unread to JAWS.
// Instead of presenting the legacy report, these instruments will have their
// scales and scores presented as simple text.
const
  SpecialReports              : string = 'ATQ^AUIR^BHS^BPRS^BSI18^BUSS^HLOC^IEQ^MBMD^MCMI2^MCMI3^MHLA^MHLB^' +
    'MMPI2^MMP2S^NEOPI^PAI^RLOC^SAI^SCL9R^SDES^SF36^STAI^VALD^WAS^ZUNG';
var
  i                           : integer;
begin
  result := false;

  for i := 1 to NumberofPieces(SpecialReports, U) do
    if aInstrumentName = Piece(SpecialReports, U, i) then
      begin
        result := true;
        break;
      end;
end;


end.

