unit uMHA_AUX_SpecialResults;

interface

uses
  SysUtils;

function GetSpecialResults: string;

implementation

function GetSpecialResults: string;
begin
  // Format:
  // Name^Height^Min^Max^SeriesCount^Guide Caption^ColorBand~
  // ColorBand is formated:
  //    Max-Min-color*Max-Min-Color*...

  Result :=
   // A Multiple scale
  'ASSIST^400^0^39^10^  Guide for interpreting ASSIST scores (range 0-39):' + #13 + #13 +
    'A Score of 27+ indicates a high health risk,' + #13 +
    'Moderate health risk, 4 - 26,' + #13 +
    'Low health risk, 0 - 3.^~' +

  // Single scale instruments
  'AUDC^200^0^12^0^  Guide for interpreting AUDC scores (range 0-12):' + #13 + #13 +
    'In men, a score of 4, or more, is considered positive; ' + #13 +
    'in women, a score of 3, or more, is considered positive.' +
    '^12-3-clRed*2-0-clGreen*~' +

  'AUDIT^200^0^41^0^  Guide for interpreting AUDIT scores (range 0-41):' + #13 + #13 +
    'A score of 8, or more, indicates a strong likelihood of hazardous or ' +
    'harmful alcohol consumption.' +
    '^41-8-clRed*7-0-clGreen*~' +

  'BAI^200^0^63^0^  Guide for interpreting BAI scores (range 0-63):' + #13 + #13 +
    '0-9: Minimal level of anxiety. 10-18: Mild anxiety. 19-29: Moderate anxiety. 30-63: Severe anxiety.' +
    '^63-30-clRed*29-19-clMaroon*18-10-clPurple*9-0-clGreen*~' +

   // A Multiple scale
  'BAM^400^0^24^3^  Guide for interpreting BAM scores (range 0-24):' + #13 + #13 +
    'A high score on the subscales Use (above 0) and Risk Factors (above 11) calls for further examination. ' +
    'A score below 13 on Protective Factors is clinically significant.^~' +

  'BAM-C^200^0^30^0^  Guide for interpreting BAM-C scores (range 0-30):' + #13 + #13 +
    'High scores indicate greater use. A score of one or greater is clinically significant.' +
    '^90-1-clRed*0-0-clGreen*~' +

   // A Multiple scale
  'BAM-IOP^400^0^24^3^  Guide for interpreting BAM-OIP scores (range 0-24):' + #13 + #13 +
    'A high score on the subscales Use (above 0) and Risk Factors (above 11) calls for further examination. ' +
    'A score below 13 on Protective Factors is clinically significant.^~' +

   // A Multiple scale
  'BAM-R^400^0^102^3^  Guide for interpreting BAM-R scores (range 0-102):' + #13 + #13 +
    'A high score on the subscales Use (above 0) and Risk Factors (above 11) calls for further examination. ' +
    'A score below 13 on Protective Factors is clinically significant.^~' +

  'BDI2^200^0^63^0^  Guide for interpreting BDI2 scores (range 0-63):' + #13 + #13 +
    '0-13: Minimal level of depression. 14-19: Mild depression. 20-28: Moderate depresion. 29-63: Severe depression.' +
    '^63-29-clRed*28-20-clMaroon*19-14-clPurple*13-0-clGreen*~' +

   // A Multiple scale
  'BASIS-24^400^0^4^6^ Guide for interpreting BASIS-24 scores is not defined. ^~' +

  'BOMC^200^0^28^0^  Guide for interpreting BOMC scores (range 0-28):' + #13 + #13 +
    'A score greater than 10 is consistent with the presence of dementia. ' +
    'Values less than 7 are considered normal for the elderly.' +
    '^28-11-clRed*10-8-clMaroon*7-0-clGreen*~' +

  'BRADEN SCALE^200^0^23^0^  Guide for interpreting BRADEN scores (range 0-23):' + #13 + #13 +
    'A low score means high risk for a pressure ulcer: ' +
    '9 or lower: Severe risk. 10-12: High risk. 13-14: Moderate risk. 15-18 Mild risk.' +
    '^23-19-clGreen*18-15-clYellow*14-13-clMaroon*12-0-clRed*~' +

  'CAGE^200^0^4^0^  Guide for interpreting CAGE (range 0-4):' + #13 + #13 +
    'A total score of 2, or greater, is considered clinically significant.' +
    '^4-2-clRed*1-0-clGreen*~' +

  'CDR^200^0^3^0^  Guide for interpreting CDR (range 0-3):' + #13 + #13 +
    'A score of 0 indicates no dementia, 0.5 - questionable, 1 - mild, ' + #13 +
    '2 - moderate, 3 - severe dementia. ' +
    '^3-3-clRed*2-2-clMaroon*1-1-clYellow*0-0-clGreen*~' +

  'CIWA-AR^200^0^67^0^  Guide for interpreting CIWA-AR (range 0-67):' + #13 + #13 +
    'The higher the score, the greater the withdrawal symptoms. ' +
    'Less than 9: Minimal. 10-19: Mild to Moderate. 20 or more: Severe.' +
    '^67-20-clRed*19-10-clMaroon*9-0-clGreen*~' +

  'COWS^200^0^67^0^  Guide for interpreting COWS (range 0-67):' + #13 + #13 +
    'The higher the score, the greater the withdrawal symptoms. ' +
    'Less than 12: Mild. 13-24: Moderate. ' +
    '25-36 Moderately severe. Above 36: Severe.' +
    '^67-37-clRed*36-25-clMaroon*24-13-clPurple*12-5-clYellow*4-0-clGreen*~' +

  'FAST^200^1^7^0^  Guide for interpreting FAST (range 1-7):' + #13 + #13 +
    'The higher the score, the greater the dementia. 1 - normal adult, ' +
    '2 - normal older adult, 3 - early dementia, 4 - mild dementia, 5 - moderate ' +
    'dementia, 6 - moderate severe dementia, 7 - severe dementia.' +
    '^7-6-clRed*5-3-clMaroon*2-1-clGreen*~' +

  'GAD-7^300^0^21^0^  Guide to interpreting of GAD-7 scores (range 0-21):' + #13 + #13 +
    'A high value indicates high level of anxiety; scores of 5, 10 and 15 indicate ' +
    'cutoffs scores for mild, moderate and severe anxiety, respectively.' +
    '^21-15-clRed*14-10-clMaroon*9-5-clYellow*4-0-clGreen*~' +

  'GAF^300^0^100^0^  Guide to interpreting of GAF scores (range 0-100):' + #13 + #13 +
    'A high value indicates high level of functioning, a low value indicates low level of functioning.' +
    '^100-61-clGreen*60-31-clMaroon*30-0-clRed*~' +

  'GDS^200^0^15^0^  Guide for interpreting GDS (range 0-15):' + #13 + #13 +
    'The higher the score, the greater the depression. Scores greater than ' +
    '5 suggest depression (be sure to follow up). ' +
    'Scores greater then 10 indicates depression.' +
    '^15-10-clRed*9-5-clMaroon*4-0-clGreen*~' +

  'GDS DEMENTIA^200^1^7^0^  Guide for interpreting GDS Dementia (range 1-7):' + #13 + #13 +
    'The higher the score, the greater the dementia. 1 - no cognitive decline, ' +
    '2 - very mild decline, 3 - mild decline, 4 - moderate decline, 5 - moderate ' +
    'severe decline, 6 - severe decline, 7 - very severe decline.' +
    '^7-6-clRed*5-3-clMaroon*2-1-clGreen*~' +

  'INDEX OF ADL^200^6^18^0^  Guide for interpreting INDEX OF ADL (range 6-18):' + #13 + #13 +
    'The higher the score, the greater the independence. ' +
    '^18-16-clGreen*15-9-clMaroon*8-0-clRed*~' +

  'PCLC^200^17^85^0^  The PTSD Check List (Civilian) contains the 17 symptoms ' +
    'of the DSM-IV diagnosis of PTSD. A high score means the PTSD symptoms were ' +
    'endorsed (range 17-85).' +
    '^85-50-clRed*49-24-clMaroon*23-17-clGreen*~' +

  'PCLM^200^17^85^0^  The PTSD Check List (Military) contains the 17 symptoms ' +
    'of the DSM-IV diagnosis of PTSD. A high score means the PTSD symptoms were ' +
    'endorsed (range 17-85).' +
    '^85-50-clRed*49-24-clMaroon*23-17-clGreen*~' +

  'PCLS^200^17^85^0^  The PTSD Check List (Specific) contains the 17 symptoms ' +
    'of the DSM-IV diagnosis of PTSD. A high score means the PTSD symptoms were ' +
    'endorsed (range 17-85).' +
    '^85-50-clRed*49-24-clMaroon*23-17-clGreen*~' +

  'PCL-SZ^200^0^68^0^  The PTSD Check List (Specific) contains the 17 symptoms ' +
    'of the DSM-IV diagnosis of PTSD. A high score means the PTSD symptoms were ' +
    'endorsed (range 0-68).' +
    '^68-33-clRed*32-6-clMaroon*5-0-clGreen*~' +

  //added for patch 105 llh
  'PC PTSD^200^0^4^0^  Guide for interpreting PC PTSD (range 0-4):' + #13 + #13 +
    'A total score of 3, or greater, is considered positive.' +
    '^4-3-clRed*2-0-clGreen*~' +

  'PHQ-2^200^0^6^0^  Guide for interpreting PHQ-2 scores (range 0-6):' + #13 + #13 +
    '0-2: The score suggests the patient may not need depression treatment. ' +
    '3-6: A score greater than 2 may indicate a depressive disorder.' +
    '^6-3-clRed*2-0-clGreen*~' +

  'PHQ9^200^0^27^0^  Guide for interpreting PHQ-9 scores (range 0-27):' + #13 + #13 +
    '0-4: The score suggests the patient may not need depression treatment.' +
    '5-14: Physician uses clinical judgment about treatment based on patient''s ' +
    'duration of symptoms and functional impairment. 15 or more: Warrants treatment for depression, using antidepressant, ' +
    'psychotherapy and/or a combination of treatments.' +
    '^27-15-clRed*14-5-clMaroon*4-0-clGreen*~' +

  // A multiple scale
  'POQ^400^0^200^7^  Guide for interpreting POQ scores (range 0-200):' + #13 + #13 +
    'The higher the score, the greater problems with pain. ' +
    '^200-145-clRed*144-97-clMaroon*96-51-clYellow*50-0-clGreen*~' +

   // A Multiple scale
  'SF36^400^2^100^8^  Guide for interpreting SF-36 scores (range 2-100):' + #13 + #13 +
    'A high value indicates a response toward good health, a low value ' +
    'indicates responses toward poor health.^~' +

  'SLUMS^200^1^30^0^  Guide for interpreting SLUMS scores (range 1-30):' + #13 + #13 +
    'Low score (1-20) indicates dementia, Mild neurocognitive disorder (21-26), ' +
    'high score (27-30) is normal functioning.' +
    '^30-27-clGreen*26-21-clMaroon*20-1-clRed*~' +

  'SMAST^200^0^13^0^  Guide for interpreting SMAST scores (range 0-13):' + #13 + #13 +
    'Two points indicate a possible problem. Three points indicate a probable problem.' +
    '^13-3-clRed*2-2-clMaroon*1-0-clGreen*~' +
(*
  'WAI-SR^200^4^20^0^  Guide for interpreting WAI scores (range 4-20):' + #13 + #13 +
    '' +
    '^*~' +
*)
  // A Multiple scale
  'WHODAS 2^400^0^100^7^  Guide for interpreting domain scores (range 0-100):' + #13 + #13 +
    'A high value indicates disability, a low value ' +
    'indicates no disability.^~' +

  'ZBI SCREEN^200^0^16^0^  Guide for interpreting ZBI Screening scores (range 0-16):' + #13 + #13 +
    'A score of 8, or higher, reflects a high burden and needs follow up.' +
    '^16-8-clRed*7-0-clGreen*~' +

  'ZBI SHORT^200^0^48^0^  Guide for interpreting ZBI Short Version scores (range 0-48):' + #13 + #13 +
    'A score of 17, or higher, reflects a high burden and needs follow up.' +
    '^48-17-clRed*16-0-clGreen*~' +

  'ZUNG^200^25^80^0^  Guide for interpreting ZUNG scores (range 25-80):' + #13 + #13 +
    '25-49: Normal range. 50-59: Mildly depressed. 60-69: Moderately depressed. ' +
    '70 and above: Severely Depressed.' +
    '^80-70-clRed*69-50-clMaroon*49-25-clGreen*~';

end;

end.

