unit uIA_Display;

interface


uses
  Classes,
  graphics,
  Forms,
  fIA_Dialogs,
  SysUtils;

type
  TAnswerComponent = (acComboBox, acCheckListBox, acListBox, acRadioGroup,
    acEdit, acMaskEdit, acSpinEdit, acMemo, acDatePicker, acTrackBar,
    acStaff, acConsult, acORCombo);

  TDisplay = class
  private
    FDisplayID: string;
    FDisplayFont: TFont;
    FDisplayLeft,
      FDisplayWidth: Integer;
    FDisplayAlignment: TAlignment;
    FDisplayMask: string;
    FDisplayColumns: Integer;
    FDisplayComponent: TAnswerComponent;
    FDisplaySameLine: Boolean;
  protected
  public

    destructor Destroy; override;
    constructor Create;

    property DisplayID: string read FDisplayID write FDisplayID;
    property DisplayFont: TFont read FDisplayFont write FDisplayFont;
    property DisplayLeft: Integer read FDisplayLeft write FDisplayLeft;
    property DisplayWidth: Integer read FDisplayWidth write FDisplayWidth;
    property DisplayAlignment: TAlignment read FDisplayAlignment write FDisplayAlignment;
    property DisplayMask: string read FDisplayMask write FDisplayMask;
    property DisplayColumns: integer read FDisplayColumns write FDisplayColumns;
    property DisplayComponent: TAnswerComponent read FDisplayComponent write FDisplayComponent;
    property DisplaySameLine: Boolean read FDisplaySameLine write FDisplaySameLine;

  published
  end; { TDisplay }

implementation

uses
  uIA_Const;

constructor TDisplay.Create;
begin
  inherited Create;
  FDisplayFont := TFont.Create;
end;

destructor TDisplay.Destroy;
begin
  if FDisplayFont <> nil then
    FDisplayFont.Free;
  inherited Destroy;
end;


end.

