unit uIA_MultiChoice_IO;

interface

uses
  SysUtils,
  fIA_dialogs,
  Trpcb,
  classes;

function ReadChoiceList(aInstrumentName: string; Broker: TRPCBroker): string;
// This is a list of all the choices for this instrument. API returns:
//  469^1^100098^One^^1
//  469^2^100099^Two^^2
//  469^3^100100^Three^^3
//  469^4^100101^Four^^4
//  480^1^100165^Low^
//  480^2^100166^Medium^
//  480^3^100752^ High^
//
//  "469" is Question.QuestionID
//  "1" is sequence
//  "100098" is MultiChoice.ChoiceID
//  "One" is text of choice item
//  "1" is legacy value

// This is converted to this format
//    Sequence^ChoiceID^Text^Legacy Value
// by Instrument.LoadQuestionChoices.

implementation

uses
  uIA_Const;



function ReadChoiceList(aInstrumentName: string; Broker: TRPCBroker): string;
var
  i                           : integer;
begin
  Result := '';

  with Broker do
    begin
      ClearParameters := True;
      ClearResults := True;
      CreateContext('YS BROKER1');
      RemoteProcedure := 'YTQ CHOICES';
      Param[0].Mult['"CODE"'] := aInstrumentName;
      Param[0].PType := List;
      Call;

      if (Results.Count = 1) or (Results[0] <> DATA) then
        begin
          Result := BAD_DATA;
          Exit;
        end;

      //Start at 1 to skip first line
      for i := 1 to Results.Count - 1 do
        Result := Result + Results[i] + RECORD_END;

      // Needed for DLL, in case there is a crash
      CreateContext('OR CPRS GUI CHART');

    end; //with DataModuleEdit.RPCBroker1
end;

end.

 