unit uIA_Question_OPS;

interface

uses
  Classes,
  SysUtils,
  uIA_Question;


type

  TQuestion_OPS = class
  private
  protected
  public
    function ConvertStringToChoiceIdentifier(AString: string): TChoiceIdentifier;
    function ConvertChoiceIdentifierToString(ChoiceIdent: TChoiceIdentifier): string;
    function ConvertStringToResponseType(AString: string): TResponseType;
    function ConvertResponseTypeToString(AResponseType: TResponseType): string;
    function ConvertRespTypeToNumberStr(AResponseType: TResponseType): string;
  published
  end;

var
  Question_OPS                : TQuestion_OPS;

implementation

uses
  uIA_Const,
  uIA_Instrument;

function TQuestion_OPS.ConvertStringToResponseType(AString: string): TResponseType;
var
  TempStr                     : string;
begin

  TempStr := UpperCase(AString);
  Result := rtString; //make this the default

  if (TempStr = MCHOICE_RT) then
    Result := rtMultiChoice;
  if (TempStr = INTEGER_RT) then
    Result := rtInteger;
  if (TempStr = DATE_RT) then
    Result := rtDate;
  if (TempStr = MEMO_RT) then
    Result := rtMemo;
  if (TempStr = CURRENCY_RT) then
    Result := rtCurrency;
  if (TempStr = VISTA_RT) then
    Result := rtVista;
  if (TempStr = MASKEDIT_RT) then
    Result := rtMaskEdit;
  if (TempStr = TRACKBAR_RT) then
    Result := rtTrackBar;
  if (TempStr = CHECKLIST_RT) then
    Result := rtCheckList;
end; //ConvertStringToResponseType


function TQuestion_OPS.ConvertResponseTypeToString(AResponseType: TResponseType): string;
begin
  Result := String_RT; //make this the default
  if (AResponseType = rtMultiChoice) then
    Result := MCHOICE_RT;
  if (AResponseType = rtInteger) then
    Result := INTEGER_RT;
  if (AResponseType = rtDate) then
    Result := DATE_RT;
  if (AResponseType = rtMemo) then
    Result := MEMO_RT;
  if (AResponseType = rtCurrency) then
    Result := CURRENCY_RT;
  if (AResponseType = rtVista) then
    Result := VISTA_RT;
  if (AResponseType = rtMaskEdit) then
    Result := MASKEDIT_RT;
  if (AResponseType = rtTrackBar) then
    Result := TRACKBAR_RT;
  if (AResponseType = rtCheckList) then
    Result := CHECKLIST_RT;
end; //ConvertToResponseType

function TQuestion_OPS.ConvertRespTypeToNumberStr(
  AResponseType: TResponseType): string;
begin
  Result := '`3'; //make this the default

  if (AResponseType = rtMultiChoice) then
    Result := '`1';
  if (AResponseType = rtInteger) then
    Result := '`2';
  if (AResponseType = rtDate) then
    Result := '`4';
  if (AResponseType = rtMemo) then
    Result := '`5';
  if (AResponseType = rtCurrency) then
    Result := '`6';
  if (AResponseType = rtTrackBar) then
    Result := '`7';
  if (AResponseType = rtVista) then      // ORComboBox
    Result := '`9';
  if (AResponseType = rtMaskEdit) then
    Result := '`10';
  if (AResponseType = rtCheckList) then
    Result := '`11';
end;


function TQuestion_OPS.ConvertStringToChoiceIdentifier(AString: string): TChoiceIdentifier;
//  TChoiceIdentifier = (ciNone, ciZeroBased, ciOneBased);
var
  TempStr                     : string;
begin
  TempStr := UpperCase(AString);
    // Make ciOneBased the default
    // This covers instances of AString = '' and AString = 'ONE'
    // None of the legacy tests, when converted, have a value for this
    // field, which is OK because all or 1-based.
  Result := ciOneBased;

  if (TempStr = 'ZERO')
    or (TempStr = '0') then
    Result := ciZeroBased;

  if (TempStr = 'NONE')
    or (TempStr = 'N') then
    Result := ciNone;
end; //ConvertStringToChoiceIdentifier


function TQuestion_OPS.ConvertChoiceIdentifierToString
  (ChoiceIdent: TChoiceIdentifier): string;
begin
  Result := 'ONE';
  if ChoiceIdent = ciZeroBased then
    Result := 'ZERO';
  if ChoiceIdent = ciNone then
    Result := 'NONE';
end;

(*
function TQuestion_OPS.Load(AQuestionID: string): TQuestion;
var
  i                           : Integer;
begin
  for i := 0 to Instrument.ListOfQuestions.Count - 1 do
    begin
      if TQuestion(Instrument.ListOfQuestions[i]).QuestionID = AQuestionID then
        begin
          Result := TQuestion(Instrument.ListOfQuestions[i]);
          break;
        end;
    end;
end; *)

(*
function TQuestion_OPS.GetCaption(QID: string): string;
var
  i                           : Integer;
begin
  Result := '';
  for i := 0 to Instrument.ListOfQuestions.Count - 1 do
    begin
      if TQuestion(Instrument.ListOfQuestions[i]).QuestionID = QID then
        begin
          Result := TQuestion(Instrument.ListOfQuestions[i]).Designator + ' ' +
            TQuestion(Instrument.ListOfQuestions[i]).Text;
          Exit;
        end;
    end; //for i
end;*)


end.

 